﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text

Public Class CreateCertRoot01
    Public CheckOk As Boolean

    Private Sub CreateCertRoot01_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug ルート認証局構築の入力画面クラスが作成されました。")
        Me.CheckOk = False
        Me.DateTimePickerNotBefore.Value = DateTime.Now
        Me.DateTimePickerNotBefore.MinDate = DateTime.Now
        Dim After5base As Date = DateTime.Now.AddYears(5)
        Me.DateTimePickerNotAfter.Value = New DateTime(After5base.Year, 3, 31, 23, 59, 59)
        If (Me.ComboBoxCSP.Items.Count = 0) Then
            Dim OStype As System.OperatingSystem = System.Environment.OSVersion
            If (OStype.Platform = System.PlatformID.Win32NT) And (OStype.Version.Major = 5) And (OStype.Version.Minor = 1) Then
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAXP)
                Me.ComboBoxCSP.Text = CommonDefines.K9cspAXP
                Debug.WriteLine("debug Win XP用の暗号プロバイダを設定します。")
            Else
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAes)
                Me.ComboBoxCSP.Text = CommonDefines.K9cspAes
                Debug.WriteLine("debug Win VISTA以後の暗号プロバイダを設定します。")
            End If
            Dim FileCheck As FileInfo = New FileInfo(CommonDefines.JPKIcheckFile)
            If FileCheck.Exists Then                                       ' JPKIのインストールを確認
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspJpk)           ' 本当はCryptAcquireContextを使いたい
            End If                                                         ' んだけどVB.NETはダメなので。
        End If
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug ルート認証局構築の入力画面を閉じます。")
        Me.CheckOk = False
        Me.Close()
    End Sub

    Private Sub ButtonOK_Click(sender As Object, e As EventArgs) Handles ButtonOK.Click
        Debug.WriteLine("debug 入力内容を確認します。")
        If Not String.IsNullOrEmpty(Me.TextBoxCountryName.Text) Then
            If Not String.IsNullOrEmpty(Me.TextBoxStateOrProvinceName.Text) Then
                If Not String.IsNullOrEmpty(Me.TextBoxOrganizationName.Text) Then
                    If Not String.IsNullOrEmpty(Me.TextBoxCommonName.Text) Then
                        If Me.DateTimePickerNotBefore.Value < Me.DateTimePickerNotAfter.Value Then
                            If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspDef) Or (Me.ComboBoxSignAlgo.Text = CommonDefines.K9sha1) Then
                                If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspDef) Or (Me.ComboBoxKeysize.Text = 1024) Then
                                    If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspJpk) Or (Me.ComboBoxSignAlgo.Text = CommonDefines.K9sha1) Then
                                        If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspJpk) Or (Me.ComboBoxKeysize.Text = 1024) Then
                                            Debug.WriteLine("debug 入力は正しく行われています。")
                                            Me.CheckOk = True
                                            Me.Close()
                                        Else
                                            Dim msg As String = "暗号プロバイダまたは鍵長を変更してください。"
                                            msg &= "「" & Me.ComboBoxCSP.Text & "」は" & Me.ComboBoxKeysize.Text & "の鍵長に対応していません。"
                                            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                                        End If
                                    Else
                                        Dim msg As String = "暗号プロバイダまたは署名アルゴリズムを変更してください。"
                                        msg &= "「" & Me.ComboBoxCSP.Text & "」は「" & Me.ComboBoxSignAlgo.Text & "」に対応していません。"
                                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                                    End If
                                Else
                                    Dim msg As String = "暗号プロバイダまたは鍵長を変更してください。"
                                    msg &= "「" & Me.ComboBoxCSP.Text & "」は" & Me.ComboBoxKeysize.Text & "の鍵長に対応していません。"
                                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                                End If
                            Else
                                Dim msg As String = "暗号プロバイダまたは署名アルゴリズムを変更してください。"
                                msg &= "「" & Me.ComboBoxCSP.Text & "」は「" & Me.ComboBoxSignAlgo.Text & "」に対応していません。"
                                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            End If
                        Else
                            Dim msg As String = "有効期間が間違っています。"
                            msg &= "開始日が終了日より後ろになっています。"
                            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        End If
                    Else
                        Dim msg As String = "一般名称／略称が間違っています。"
                        msg &= "値を入力してください。"
                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    Dim msg As String = "組織名／正式名称が間違っています。"
                    msg &= "値を入力してください。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                Dim msg As String = "都道府県が間違っています。"
                msg &= "値を入力してください。"
                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Else
            Dim msg As String = "国が間違っています。"
            msg &= "値を入力してください。"
            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub ComboBoxCSP_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBoxCSP.SelectedIndexChanged
        If (Me.ComboBoxCSP.Text = CommonDefines.K9cspDef) Or (Me.ComboBoxCSP.Text = CommonDefines.K9cspJpk) Then
            Me.ComboBoxKeysize.Text = "1024"
            Me.ComboBoxSignAlgo.Text = "SHA-1"
        End If
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot10.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel2_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel2.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot13.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel3_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel3.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot14.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel4_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel4.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot15.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel5_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel5.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot16.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel6_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel6.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot18.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel7_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel7.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot25.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel8_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel8.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot34.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel9_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel9.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot35.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel10_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel10.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertRoot36.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub
End Class