﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class CreateCertRoot03
    Public RGdata As RegistData
    Public K9piaExecDirectory As String
    Public K9piaExecName As String
    Public K9piaCertDirectoryBase As String
    Public SerialNumber As Long
    Public CountryName As String
    Public StateOrProvinceName As String
    Public LocalityName As String
    Public OrganizationName As String
    Public CommonName As String
    Public NotBefore As Date
    Public NotAfter As Date
    Public CertificatePolicies As String
    Public AnyPolicyUsed As Boolean
    Public PolicyOID As String
    Public CRLDistributionPoints As String
    Public AuthorityInfoAccess As String
    Public Keysize As Integer
    Public SignAlgo As String
    Public ProviderName As String
    Public CheckOk As Boolean
    Public RetCode As Integer
    Private BreakFlag As Boolean
    Private LOGdata As LogFile

    Private Sub CreateCertRoot03_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug ルート認証局構築の実行画面クラスが作成されました。")
        Me.CheckOk = False                                             ' コンストラクタ：初期化します
        Me.RetCode = -1
        Me.LabelCreateEnd.ForeColor = SystemColors.Control             ' 完了メッセージを背景色と同じにして見えなくさせます
        Me.LabelRegistEnd.ForeColor = SystemColors.Control
        Me.LabelAllEnd.ForeColor = SystemColors.Control
        Me.BreakFlag = False
        Me.LOGdata = New LogFile()
    End Sub

    Private Sub CreateCertRoot03_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug ルート認証局構築の実行画面クラスが表示されました。")
        Me.BackgroundWorker1.RunWorkerAsync()                          ' 表示と同時にバックグラウンド処理を開始します
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug ルート認証局構築の実行画面で〔キャンセル〕が押されました。")
        Me.CheckOk = False                                             ' キャンセル処理です
        Me.BreakFlag = True
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim LGfile As LogFile = New LogFile
        Debug.WriteLine("debug ルート認証局構築のバックグラウンド処理を開始します。")
        Dim SNdirectory As String                                      ' バックグラウンド処理です
        If Me.SerialNumber < 10000 Then
            SNdirectory = Me.SerialNumber.ToString("D4")
        ElseIf Me.SerialNumber < 100000000 Then
            SNdirectory = Me.SerialNumber.ToString("D8")
        Else
            SNdirectory = Me.SerialNumber.ToString("D64")
        End If
        Dim CheckDir As DirectoryInfo = New DirectoryInfo(Me.K9piaCertDirectoryBase)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & "を作成しました。")
        End If
        CheckDir = New DirectoryInfo(Me.K9piaCertDirectoryBase + SNdirectory)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & SNdirectory & "を作成しました。")
        End If
        Dim K9pia As k9piaCertIssue = New k9piaCertIssue               ' 発行局(k9pia)との接続を開始します
        K9pia.K9piaExecDirectory = Me.K9piaExecDirectory
        K9pia.K9piaExecName = Me.K9piaExecName
        K9pia.SerialNumber = Me.SerialNumber
        K9pia.SignatureAlgorithm = Me.SignAlgo
        K9pia.Issuer = 0
        K9pia.NotBefore = Me.NotBefore
        K9pia.NotAfter = Me.NotAfter
        K9pia.Country = Me.CountryName
        K9pia.StateOrProvince = Me.StateOrProvinceName
        If Not String.IsNullOrEmpty(Me.LocalityName) Then K9pia.Locality = Me.LocalityName
        K9pia.Organization = Me.OrganizationName
        K9pia.CommonName = Me.CommonName
        K9pia.BasicConst = True
        K9pia.PathLen = -1
        If Me.ProviderName = CommonDefines.K9cspDef Then
            K9pia.ProviderType = CommonDefines.K9cspDefType
            K9pia.ProviderName = CommonDefines.K9cspDef
        ElseIf Me.ProviderName = CommonDefines.K9cspAes Then
            K9pia.ProviderType = CommonDefines.K9cspAesType
            K9pia.ProviderName = CommonDefines.K9cspAes
        ElseIf Me.ProviderName = CommonDefines.K9cspAXP Then
            K9pia.ProviderType = CommonDefines.K9cspAXPType
            K9pia.ProviderName = CommonDefines.K9cspAXP
        ElseIf Me.ProviderName = CommonDefines.K9cspJpk Then
            K9pia.ProviderType = CommonDefines.K9cspJpkType
            K9pia.ProviderName = CommonDefines.K9cspJpk
        Else
            K9pia.ProviderType = CommonDefines.K9cspDefType
            K9pia.ProviderName = CommonDefines.K9cspDef
        End If
        K9pia.Keysize = Me.Keysize
        K9pia.CertFilename = Me.K9piaCertDirectoryBase & SNdirectory & "/" & Me.SerialNumber.ToString()
        K9pia.CertExtend = CommonDefines.K9extCER
        If Not Me.BreakFlag Then
            Me.RetCode = K9pia.sendCommand()                           ' 発行局にルート認証局証明書作成を指示します
            Debug.WriteLine("debug 発行局もどり値 [" & Me.RetCode.ToString() & "]")
            Me.LOGdata.Logout("--------------------------------------------------------------------------------")
            If Me.RetCode = 0 Then
                Me.LOGdata.Logout("ルート認証局証明書を発行しました。")
            Else
                Me.LOGdata.Logout("ルート認証局証明書の発行に失敗しました。")
            End If
        Else
            Me.RetCode = -3
            Me.LOGdata.Logout("ルート認証局証明書の発行がキャンセルされました。")
        End If
        If Me.RetCode = 0 Then
            Me.RetCode = -2                                            ' 終了コードを変更して処理を続けます
            Me.LabelCreateEnd.ForeColor = SystemColors.ControlText     ' 完了メッセージを黒にして見えるようにします
            RGdata.StackString(CommonDefines.RecordVersion, CommonDefines.K9certVer) ' 登録情報ファイルに書き込みます
            RGdata.StackLong(CommonDefines.RecordSirinumber, Me.SerialNumber)
            RGdata.StackString(CommonDefines.RecordSignalgo, Me.SignAlgo)
            RGdata.StackLong(CommonDefines.RecordIssuer, 0)
            RGdata.StackString(CommonDefines.RecordNotbefore, DateTime.Parse(Me.NotBefore.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.StackString(CommonDefines.RecordNotafter, DateTime.Parse(Me.NotAfter.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.StackString(CommonDefines.RecordContry, Me.CountryName)
            RGdata.StackString(CommonDefines.RecordStateprov, Me.StateOrProvinceName)
            If Not String.IsNullOrEmpty(Me.LocalityName) Then
                RGdata.StackString(CommonDefines.RecordLocality, Me.LocalityName)
            End If
            RGdata.StackString(CommonDefines.RecordOrganiz, Me.OrganizationName)
            RGdata.StackString(CommonDefines.RecordComname, Me.CommonName)
            RGdata.StackLong(CommonDefines.RecordBccae, 1)
            RGdata.StackLong(CommonDefines.RecordBcpath, -1)
            If Not String.IsNullOrEmpty(Me.CertificatePolicies) Then
                RGdata.StackString(CommonDefines.RecordCpUri, Me.CertificatePolicies)
                If Me.AnyPolicyUsed Then
                    RGdata.StackString(CommonDefines.RecordCpOID, CommonDefines.K9anyP)
                Else
                    RGdata.StackString(CommonDefines.RecordCpOID, Me.PolicyOID)
                End If
            End If
            If Not String.IsNullOrEmpty(Me.CRLDistributionPoints) Then
                RGdata.StackString(CommonDefines.RecordCRLdpUrl, Me.CRLDistributionPoints)
            End If
            If Not String.IsNullOrEmpty(Me.AuthorityInfoAccess) Then
                RGdata.StackString(CommonDefines.RecordAinfoCA, Me.AuthorityInfoAccess)
            End If
            If Me.ProviderName = CommonDefines.K9cspDef Then
                RGdata.StackString(CommonDefines.RecordCSPtype, CommonDefines.K9cspDefType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspDef)
            ElseIf Me.ProviderName = CommonDefines.K9cspAes Then
                RGdata.StackString(CommonDefines.RecordCSPtype, CommonDefines.K9cspAesType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspAes)
            ElseIf Me.ProviderName = CommonDefines.K9cspAXP Then
                RGdata.StackString(CommonDefines.RecordCSPtype, CommonDefines.K9cspAXPType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspAXP)
            ElseIf Me.ProviderName = CommonDefines.K9cspJpk Then
                RGdata.StackString(CommonDefines.RecordCSPtype, CommonDefines.K9cspJpkType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspJpk)
            Else
                RGdata.StackString(CommonDefines.RecordCSPtype, CommonDefines.K9cspDefType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspDef)
            End If
            RGdata.StackLong(CommonDefines.RecordKeysize, Me.Keysize.ToString())
            RGdata.SetupCurrentType(CommonDefines.BlockRoot)
            If Not Me.BreakFlag Then
                RGdata.WriteStack()
                Me.LabelRegistEnd.ForeColor = SystemColors.ControlText ' 完了メッセージを黒にして見えるようにします
                Me.LabelAllEnd.ForeColor = SystemColors.ControlText
                Me.CheckOk = True                                      ' 終了コードに正常終了を設定します
                Me.RetCode = 0                                         ' 完了メッセージ確認のためにちょっと待ち
                System.Threading.Thread.Sleep(CommonDefines.MessageDilayTime)
                Me.LOGdata.Logout("ルート認証局を構築しました。")
            Else
                RGdata.CancelStack()
                Me.RetCode = -3
                Me.LOGdata.Logout("ルート認証局の構築がキャンセルされました。。")
            End If
        Else
            Me.LabelCreateEnd.Text = "… 失敗しました"                 ' 発行局でエラーの場合
            Me.LabelCreateEnd.ForeColor = SystemColors.ControlText
        End If                                                         ' 続けてバックグラウンド処理の終了イベントに移ります
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Dim LGfile As LogFile = New LogFile
        Debug.WriteLine("debug バックグラウンド処理の終了値 [" & Me.RetCode.ToString() & "]")
        If Me.RetCode <> 0 Then                                        ' バックグラウンド処理の終了イベントです
            Dim msg As String = "ルート認証局の構築が失敗しました。"   ' エラーがあれば、ここでメッセージを表示します
            msg &= "エラーコード：" & Me.RetCode.ToString()
            If Me.RetCode = CommonDefines.ErrorCodeK9piaKeys Then
                msg &= " 再実行によりエラーが解消する場合があります。"
            ElseIf Me.RetCode = CommonDefines.ErrorCodeK9piaMakefile Then
                msg &= " フォルダの書き込み権限を確認してください。"
            End If
            MessageBox.Show(msg, "構築の失敗", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.CheckOk = False
        End If
        Me.Close()                                                     ' 画面を閉じます
    End Sub
End Class