﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text

Public Class CreateCertUser01
    Public CheckOk As Boolean
    Public RGdata As RegistData
    Public AuthList As AuthorityListBlock

    Private Sub CreateCertUser01_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 個人証明書の入力画面クラスが作成されました。")
        Me.CheckOk = False
        Me.TextBoxFilename.Text = ""
        Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
        Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
        Me.ButtonOK.Enabled = False
    End Sub

    Private Sub CreateCertUser01_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 個人証明書の入力画面クラスが表示されました。")
        Me.AuthList = New AuthorityListBlock
        Me.AuthList.GetArray(Me.RGdata)
        If (AuthList.Length > 0) Then
            Me.ComboBoxAuthority.ForeColor = System.Drawing.SystemColors.ControlText
            If Me.ComboBoxAuthority.Items.Count = 0 Then
                For i As Integer = 0 To Me.AuthList.Length - 1 Step 1
                    Dim NodeTitle As String = String.Format("{0} {1}", Me.AuthList.SerialNumber(i), Me.AuthList.Organization(i))
                    Me.ComboBoxAuthority.Items.Add(NodeTitle)
                Next
            Else
                Debug.WriteLine("debug 認証局が作成済みです。")
            End If
            Me.TextBoxFilename.Text = ""
            Me.TextBoxCountryName.Text = Me.AuthList.Country(0)
            Me.TextBoxStateOrProvinceName.Text = Me.AuthList.StateOrProvince(0)
            Me.TextBoxLocalityName.Text = Me.AuthList.Locality(0)
            Me.TextBoxOrganizationName.Text = Me.AuthList.Organization(0)
            Me.TextBoxOrganizationUnitName.Text = Me.AuthList.OrganizationUnit(0)
            If Me.AuthList.NotBefore(0) < Date.Now() Then
                Me.DateTimePickerNotBefore.MinDate = Date.Now()
                Me.DateTimePickerNotBefore.Value = Date.Now()
                Me.DateTimePickerNotAfter.MinDate = Date.Now()
            Else
                Me.DateTimePickerNotBefore.MinDate = Me.AuthList.NotBefore(0)
                Me.DateTimePickerNotBefore.Value = Me.AuthList.NotBefore(0)
                Me.DateTimePickerNotAfter.MinDate = Me.AuthList.NotBefore(0)
            End If
            Me.DateTimePickerNotBefore.MaxDate = Me.AuthList.NotAfter(0)
            Me.DateTimePickerNotAfter.MaxDate = Me.AuthList.NotAfter(0)
            Dim After1base As Date = Me.DateTimePickerNotBefore.Value.ToLocalTime().AddYears(1)
            Dim After1matsu As Date = New DateTime(After1base.Year, 3, 31, 23, 59, 59)
            If After1matsu < Me.AuthList.NotAfter(0) Then
                Me.DateTimePickerNotAfter.Value = After1matsu
            Else
                Me.DateTimePickerNotAfter.Value = Me.AuthList.NotAfter(0)
            End If
            If (Me.ComboBoxCSP.Items.Count <> 0) Then
                Me.ComboBoxCSP.Items.Clear()
            End If
            Me.ComboBoxKeysize.Items.Clear()
            Dim OStype As System.OperatingSystem = System.Environment.OSVersion
            If (OStype.Platform = System.PlatformID.Win32NT) And (OStype.Version.Major = 5) And (OStype.Version.Minor = 1) Then
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
                If Me.AuthList.SignatureAlgorithm(0) = CommonDefines.K9sha1 Then
                    Me.ComboBoxCSP.Text = CommonDefines.K9cspDef
                    Me.ComboBoxKeysize.Items.Add(1024)
                    Me.ComboBoxKeysize.Text = "1024"
                Else
                    Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAXP)
                    Me.ComboBoxCSP.Text = CommonDefines.K9cspAXP
                    Me.ComboBoxKeysize.Items.Add(1024)
                    Me.ComboBoxKeysize.Items.Add(2048)
                    Me.ComboBoxKeysize.Items.Add(4096)
                    Me.ComboBoxKeysize.Text = "1024"
                End If
            Else
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
                If Me.AuthList.SignatureAlgorithm(0) = CommonDefines.K9sha1 Then
                    Me.ComboBoxCSP.Text = CommonDefines.K9cspDef
                    Me.ComboBoxKeysize.Items.Add(1024)
                    Me.ComboBoxKeysize.Text = "1024"
                Else
                    Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAes)
                    Me.ComboBoxCSP.Text = CommonDefines.K9cspAes
                    Me.ComboBoxKeysize.Items.Add(1024)
                    Me.ComboBoxKeysize.Items.Add(2048)
                    Me.ComboBoxKeysize.Items.Add(4096)
                    Me.ComboBoxKeysize.Text = "1024"
                End If
            End If
            Dim FileCheck As FileInfo = New FileInfo(CommonDefines.JPKIcheckFile)
            If Not FileCheck.Exists Then
                If Me.AuthList.ProviderName(0) = CommonDefines.K9cspJpk Then
                    Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                    MessageBox.Show(msg)
                    Me.ButtonOK.Enabled = False
                End If
            End If
            Me.TextBoxSignAlgo.Text = Me.AuthList.SignatureAlgorithm(0)
            Me.ComboBoxAuthority.Text = String.Format("{0} {1}", Me.AuthList.SerialNumber(0), Me.AuthList.Organization(0))
            Me.ButtonOK.Enabled = True
        Else
            Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
            Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
            Me.ButtonOK.Enabled = False
        End If
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 個人証明書の入力画面を閉じます。")
        Me.CheckOk = False
        Me.Close()
    End Sub

    Private Sub ButtonOK_Click(sender As Object, e As EventArgs) Handles ButtonOK.Click
        Debug.WriteLine("debug 入力内容を確認します。")
        Dim Checker As KeyinCheck = New KeyinCheck()
        Dim Check1st As Boolean = False
        If Not String.IsNullOrEmpty(Me.TextBoxCountryName.Text) Then
            If Not String.IsNullOrEmpty(Me.TextBoxOrganizationName.Text) Then
                If Not String.IsNullOrEmpty(Me.TextBoxCommonName.Text) Then
                    If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspDef) Or (Me.ComboBoxKeysize.Text = 1024) Then
                        If (Me.ComboBoxCSP.Text <> CommonDefines.K9cspJpk) Or (Me.ComboBoxKeysize.Text = 1024) Then
                            If Me.TextBoxEmail.Text = "" Then
                                Check1st = True
                            ElseIf Checker.Check4Email(Me.TextBoxEmail.Text) Then
                                Check1st = True
                            Else
                                Dim msg As String = "メールアドレスが間違っています。"
                                msg &= "メールアドレスに使用できない文字が含まれています。"
                                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            End If
                        Else
                            Dim msg As String = "暗号プロバイダまたは鍵長を変更してください。"
                            msg &= "「" & Me.ComboBoxCSP.Text & "」は" & Me.ComboBoxKeysize.Text & "の鍵長に対応していません。"
                            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        End If
                    Else
                        Dim msg As String = "暗号プロバイダまたは鍵長を変更してください。"
                        msg &= "「" & Me.ComboBoxCSP.Text & "」は" & Me.ComboBoxKeysize.Text & "の鍵長に対応していません。"
                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    Dim msg As String = "氏名が間違っています。"
                    msg &= "値を入力してください。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                Dim msg As String = "組織が間違っています。"
                msg &= "値を入力してください。"
                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Else
            Dim msg As String = "国が間違っています。"
            msg &= "値を入力してください。"
            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
        If Check1st Then
            Dim Check2nd As Boolean = False
            If Me.DateTimePickerNotBefore.Value < Me.DateTimePickerNotAfter.Value Then
                If (Me.TextBoxCertificatePolicies.Text = "") Or (Me.RadioButtonAnyPolicy.Checked) _
                Or (Me.RadioButtonPolicyOID.Checked And (Not String.IsNullOrEmpty(Me.TextBoxPolicyOID.Text)) And Checker.Check4oid(Me.TextBoxPolicyOID.Text)) Then
                    If Not String.IsNullOrEmpty(Me.TextBoxFilename.Text) Then
                        Check2nd = True
                    ElseIf String.IsNullOrEmpty(Me.TextBoxPassword.Text) Then
                        Dim msg As String = "パスワードが間違っています。"
                        msg &= "値を入力してください。"
                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    ElseIf Checker.Check4Password(Me.TextBoxPassword.Text) Then
                        Check2nd = True
                        If Me.TextBoxPassword.Text.Length < 8 Then
                            Dim msg As String = "警告：パスワードが、8文字以下です。"
                            MessageBox.Show(msg)
                        End If
                    Else
                        Dim msg As String = "パスワードが間違っています。"
                        msg &= "パスワードに使用できない文字が含まれています。"
                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    Dim msg As String = "ポリシー識別子(OID)が指定されていません。"
                    msg &= "または、ポリシー識別子(OID)に指定できない文字が含まれています。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                Dim msg As String = "有効期間が間違っています。"
                msg &= "開始日が終了日より後ろになっています。"
                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
            If Check2nd Then
                Debug.WriteLine("debug 入力は正しく行われています。")
                Me.CheckOk = True
                Me.Close()
            End If
        End If
    End Sub

    Private Sub ComboBoxAuthority_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBoxAuthority.SelectedIndexChanged
        Dim AuthListID As Integer = Me.ComboBoxAuthority.SelectedIndex
        Me.TextBoxFilename.Text = ""
        Me.TextBoxCountryName.Text = Me.AuthList.Country(AuthListID)
        Me.TextBoxStateOrProvinceName.Text = Me.AuthList.StateOrProvince(AuthListID)
        Me.TextBoxLocalityName.Text = Me.AuthList.Locality(AuthListID)
        Me.TextBoxOrganizationName.Text = Me.AuthList.Organization(AuthListID)
        Me.TextBoxOrganizationUnitName.Text = Me.AuthList.OrganizationUnit(AuthListID)
        If Me.AuthList.NotBefore(AuthListID) < Date.Now() Then
            Me.DateTimePickerNotBefore.MinDate = Date.Now()
            Me.DateTimePickerNotBefore.Value = Date.Now()
            Me.DateTimePickerNotAfter.MinDate = Date.Now()
        Else
            Me.DateTimePickerNotBefore.MinDate = Me.AuthList.NotBefore(AuthListID)
            Me.DateTimePickerNotBefore.Value = Me.AuthList.NotBefore(AuthListID)
            Me.DateTimePickerNotAfter.MinDate = Me.AuthList.NotBefore(AuthListID)
        End If
        Me.DateTimePickerNotBefore.MaxDate = Me.AuthList.NotAfter(AuthListID)
        Me.DateTimePickerNotAfter.MaxDate = Me.AuthList.NotAfter(AuthListID)
        Dim After1base As Date = Me.DateTimePickerNotBefore.Value.ToLocalTime().AddYears(1)
        Dim After1matsu As Date = New DateTime(After1base.Year, 3, 31, 23, 59, 59)
        If After1matsu < Me.AuthList.NotAfter(AuthListID) Then
            Me.DateTimePickerNotAfter.Value = After1matsu
        Else
            Me.DateTimePickerNotAfter.Value = Me.AuthList.NotAfter(AuthListID)
        End If
        Me.ComboBoxCSP.Items.Clear()
        Me.ComboBoxKeysize.Items.Clear()
        Dim OStype As System.OperatingSystem = System.Environment.OSVersion
        If (OStype.Platform = System.PlatformID.Win32NT) And (OStype.Version.Major = 5) And (OStype.Version.Minor = 1) Then
            Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
            If Me.AuthList.SignatureAlgorithm(AuthListID) = CommonDefines.K9sha1 Then
                Me.ComboBoxCSP.Text = CommonDefines.K9cspDef
                Me.ComboBoxKeysize.Items.Add(1024)
                Me.ComboBoxKeysize.Text = "1024"
            Else
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAXP)
                Me.ComboBoxCSP.Text = CommonDefines.K9cspAXP
                Me.ComboBoxKeysize.Items.Add(1024)
                Me.ComboBoxKeysize.Items.Add(2048)
                Me.ComboBoxKeysize.Items.Add(4096)
                Me.ComboBoxKeysize.Text = "1024"
            End If
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspAes Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            Else
                Me.ButtonOK.Enabled = True
            End If
        Else
            Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspDef)
            If Me.AuthList.SignatureAlgorithm(AuthListID) = CommonDefines.K9sha1 Then
                Me.ComboBoxCSP.Text = CommonDefines.K9cspDef
                Me.ComboBoxKeysize.Items.Add(1024)
                Me.ComboBoxKeysize.Text = "1024"
            Else
                Me.ComboBoxCSP.Items.Add(CommonDefines.K9cspAes)
                Me.ComboBoxCSP.Text = CommonDefines.K9cspAes
                Me.ComboBoxKeysize.Items.Add(1024)
                Me.ComboBoxKeysize.Items.Add(2048)
                Me.ComboBoxKeysize.Items.Add(4096)
                Me.ComboBoxKeysize.Text = "1024"
            End If
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspAXP Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            Else
                Me.ButtonOK.Enabled = True
            End If
        End If
        Dim FileCheck As FileInfo = New FileInfo(CommonDefines.JPKIcheckFile)
        If Not FileCheck.Exists Then
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspJpk Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            End If
        End If
        Me.TextBoxSignAlgo.Text = Me.AuthList.SignatureAlgorithm(AuthListID)
    End Sub

    Private Sub ButtonCSR_Click(sender As Object, e As EventArgs) Handles ButtonCSR.Click
        Dim FormCSRselect As SelectCSR = New SelectCSR
        FormCSRselect.Location = Me.Location
        FormCSRselect.ShowDialog()
        If FormCSRselect.CheckOk Then
            Me.TextBoxFilename.Text = FormCSRselect.TextBoxFilename.Text
            If FormCSRselect.CheckBoxCountryName.Checked Then
                Me.TextBoxCountryName.Text = FormCSRselect.LabelCountryName.Text
            End If
            If FormCSRselect.CheckBoxStateOrProvinceName.Checked Then
                Me.TextBoxStateOrProvinceName.Text = FormCSRselect.LabelStateOrProvinceName.Text
            End If
            If FormCSRselect.CheckBoxLocalityName.Checked Then
                Me.TextBoxLocalityName.Text = FormCSRselect.LabelLocalityName.Text
            End If
            If FormCSRselect.CheckBoxOrganizationName.Checked Then
                Me.TextBoxOrganizationName.Text = FormCSRselect.LabelOrganizationName.Text
            End If
            If FormCSRselect.CheckBoxOrganizationUnitName.Checked Then
                Me.TextBoxOrganizationUnitName.Text = FormCSRselect.LabelOrganizationUnitName.Text
            End If
            If FormCSRselect.CheckBoxCommonName.Checked Then
                Me.TextBoxCommonName.Text = FormCSRselect.LabelCommonName.Text
            End If
            If FormCSRselect.CheckBoxEmail.Checked Then
                Me.TextBoxEmail.Text = FormCSRselect.LabelEmail.Text
            End If
        End If
        Me.TextBoxPassword.Text = ""
        Me.TextBoxPassword.ReadOnly = True
        Me.TextBoxPassword.BackColor = SystemColors.Control
        Me.CheckBoxWithCert.Checked = False
        Me.CheckBoxWithCert.Enabled = False
    End Sub

    Private Sub ButtonClear_Click(sender As Object, e As EventArgs) Handles ButtonClear.Click
        Me.TextBoxFilename.Text = ""
        Me.TextBoxPassword.Text = ""
        Me.TextBoxPassword.ReadOnly = False
        Me.TextBoxPassword.BackColor = SystemColors.Window
        Me.CheckBoxWithCert.Enabled = True
    End Sub

    Private Sub RadioButtonAnyPolicy_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButtonAnyPolicy.CheckedChanged
        If Me.RadioButtonAnyPolicy.Checked Then
            Me.TextBoxPolicyOID.Enabled = False
            Me.TextBoxPolicyOID.BackColor = System.Drawing.Color.WhiteSmoke
        Else
            Me.TextBoxPolicyOID.Enabled = True
            Me.TextBoxPolicyOID.BackColor = System.Drawing.Color.White
        End If
    End Sub

    Private Sub ButtonPicture_Click(sender As Object, e As EventArgs) Handles ButtonPicture.Click
        Dim FormPicSelect As SelectPicture = New SelectPicture
        FormPicSelect.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
        FormPicSelect.ShowDialog()
        If FormPicSelect.CheckOk Then
            Me.TextBoxPicture.Text = FormPicSelect.TextBoxFilename.Text
        End If
    End Sub

    Private Sub ButtonPictureClear_Click(sender As Object, e As EventArgs) Handles ButtonPictureClear.Click
        Me.TextBoxPicture.Text = ""
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser10.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel2_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel2.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser11.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel3_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel3.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser12.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel4_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel4.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser13.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel5_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel5.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser14.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel6_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel6.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser15.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel7_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel7.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser16.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel8_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel8.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser17.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel9_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel9.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser18.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel19_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel19.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser19.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel10_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel10.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser25.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel12_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel12.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser27.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel13_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel13.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser28.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel14_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel14.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser29.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel15_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel15.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser30.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel20_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel20.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser31.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel21_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel21.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser32.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel16_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel16.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser34.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel17_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel17.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser35.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel18_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel18.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser36.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel11_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel11.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser45.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel22_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel22.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateCertUser37.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub
End Class