﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text

Public Class CreateX509crl01
    Public CheckOk As Boolean
    Public BIdata As BaseInfoData
    Public RGdata As RegistData
    Public AuthList As AuthorityListBlock

    Private Sub CreateX509crl01_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 失効リストの入力画面クラスが作成されました。")
        Me.CheckOk = False
        Me.TextBoxSubject.Text = ""
        Me.TextBoxNextUpdate.Text = ""
        Me.DateTimePickerThisUpdate.Value = Date.Now.ToLocalTime().AddSeconds(60)
        Me.DateTimePickerThisUpdate.MinDate = Date.Now.ToLocalTime()
        Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
        Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
        Me.ButtonOK.Enabled = False
    End Sub

    Private Sub CreateX509crl01_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 失効リストの入力画面クラスが表示されました。")
        Me.AuthList = New AuthorityListBlock
        Me.AuthList.GetArray(Me.RGdata)
        If Me.AuthList.Length > 0 Then
            Me.ComboBoxAuthority.ForeColor = System.Drawing.SystemColors.ControlText
            If Me.ComboBoxAuthority.Items.Count = 0 Then
                For i As Integer = 0 To Me.AuthList.Length - 1 Step 1
                    Dim NodeTitle As String = String.Format("{0} {1}", Me.AuthList.SerialNumber(i), Me.AuthList.Organization(i))
                    Me.ComboBoxAuthority.Items.Add(NodeTitle)
                Next
            Else
                Debug.WriteLine("debug 認証局が作成済みです。")
            End If
            Me.ComboBoxAuthority.Text = String.Format("{0} {1}", Me.AuthList.SerialNumber(0), Me.AuthList.Organization(0))
            Me.ListupSubject()
            ' Me.ButtonOK.Enabled = True
        Else
            Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
            Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
            Me.TextBoxNextUpdate.Text = ""
            Me.TextBoxSubject.Text = ""
            Me.ButtonOK.Enabled = False
        End If
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 失効リストの入力画面を閉じます。")
        Me.CheckOk = False
        Me.Close()
    End Sub

    Private Sub ButtonOK_Click(sender As Object, e As EventArgs) Handles ButtonOK.Click
        Debug.WriteLine("debug 入力内容を確認します。")
        If Me.AuthList.Length > 0 Then
            If Not String.IsNullOrEmpty(Me.TextBoxNextUpdate.Text) Then
                Me.CheckOk = True
                Me.Close()
            End If
        End If
    End Sub

    Private Sub ComboBoxAuthority_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBoxAuthority.SelectedIndexChanged
        Dim AuthListID As Integer = Me.ComboBoxAuthority.SelectedIndex
        Me.ListupSubject()
        Dim OStype As System.OperatingSystem = System.Environment.OSVersion
        If (OStype.Platform = System.PlatformID.Win32NT) And (OStype.Version.Major = 5) And (OStype.Version.Minor = 1) Then
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspAes Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            Else
                Me.ButtonOK.Enabled = True
            End If
        Else
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspAXP Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            Else
                Me.ButtonOK.Enabled = True
            End If
        End If
        Dim FileCheck As FileInfo = New FileInfo(CommonDefines.JPKIcheckFile)
        If Not FileCheck.Exists Then
            If Me.AuthList.ProviderName(AuthListID) = CommonDefines.K9cspJpk Then
                Dim msg As String = "警告：このパソコンでサポートしていない暗号プロバイダを使った認証局を選択しています。"
                MessageBox.Show(msg)
                Me.ButtonOK.Enabled = False
            End If
        End If
    End Sub

    Private Sub DateTimePickerThisUpdate_ValueChanged(sender As Object, e As EventArgs) Handles DateTimePickerThisUpdate.ValueChanged
        If Me.BIdata IsNot Nothing Then
            If Me.BIdata.CrlCycle = CommonDefines.CrlCycleYear4 Then
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddYears(1)
                Dim AfterIppi As Date = New DateTime(Afterbase.Year, 4, 1, 0, 0, 0)
                Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
            ElseIf Me.BIdata.CrlCycle = CommonDefines.CrlCycleYear10 Then
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddYears(1)
                Dim AfterIppi As Date = New DateTime(Afterbase.Year, 10, 1, 0, 0, 0)
                Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
            ElseIf Me.BIdata.CrlCycle = CommonDefines.CrlCycleHalf Then
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddMonths(6)
                If Afterbase.Month < 7 Then
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 1, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                Else
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 7, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                End If
            ElseIf Me.BIdata.CrlCycle = CommonDefines.CrlCycleQuarter Then
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddMonths(3)
                If Afterbase.Month < 4 Then
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 1, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                ElseIf Afterbase.Month < 7 Then
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 4, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                ElseIf Afterbase.Month < 10 Then
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 7, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                Else
                    Dim AfterIppi As Date = New DateTime(Afterbase.Year, 10, 1, 0, 0, 0)
                    Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
                End If
            ElseIf Me.BIdata.CrlCycle = CommonDefines.CrlCycleMonthly Then
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddMonths(1)
                Dim AfterIppi As Date = New DateTime(Afterbase.Year, Afterbase.Month, 1, 0, 0, 0)
                Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
            Else
                Dim Afterbase As Date = Me.DateTimePickerThisUpdate.Value.ToLocalTime().AddMonths(1)
                Dim AfterIppi As Date = New DateTime(Afterbase.Year, Afterbase.Month, 1, 0, 0, 0)
                Me.TextBoxNextUpdate.Text = AfterIppi.ToString("yyyy/MM/dd 00:00:00")
            End If
            Me.ListupSubject()
        Else
            Me.TextBoxNextUpdate.Text = ""
            Me.TextBoxSubject.Text = ""
        End If
    End Sub

    Private Sub ListupSubject()
        Debug.WriteLine("debug 失効証明書の一覧を表示します。")
        Me.TextBoxSubject.Text = ""
        If Me.AuthList IsNot Nothing Then
            If Me.AuthList.Length > 0 Then
                Dim AuthListID As Integer = Me.ComboBoxAuthority.SelectedIndex
                Dim Issuer As Long = Me.AuthList.SerialNumber(AuthListID)
                Dim Subject As String = ""
                Dim ChildList() As Long = Me.RGdata.GetMiddleList(Issuer)
                If ChildList IsNot Nothing Then
                    For j As Integer = 0 To ChildList.Length - 1 Step 1
                        Dim ChildNum As Long = ChildList(j)
                        If ChildNum > 0 Then
                            Dim BeforeTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            Dim AfterTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            If (BeforeTemp <= Me.DateTimePickerThisUpdate.Value) And (Me.DateTimePickerThisUpdate.Value <= AfterTemp) Then
                                Dim RstrTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                                If Not String.IsNullOrEmpty(RstrTemp) Then
                                    Dim RevoTemp As Date = Date.Parse(RstrTemp)
                                    If RevoTemp <= Me.DateTimePickerThisUpdate.Value Then
                                        Dim OrgTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganiz)
                                        Dim ReasonTemp As String
                                        Dim RCodeTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                                        If Not String.IsNullOrEmpty(RCodeTemp) Then
                                            If RCodeTemp = "1" Then
                                                ReasonTemp = CommonDefines.ReasonMsg1
                                            ElseIf RCodeTemp = "2" Then
                                                ReasonTemp = CommonDefines.ReasonMsg2
                                            ElseIf RCodeTemp = "3" Then
                                                ReasonTemp = CommonDefines.ReasonMsg3
                                            ElseIf RCodeTemp = "4" Then
                                                ReasonTemp = CommonDefines.ReasonMsg4
                                            ElseIf RCodeTemp = "5" Then
                                                ReasonTemp = CommonDefines.ReasonMsg5
                                            Else
                                                ReasonTemp = CommonDefines.ReasonMsg6
                                            End If
                                            Subject += String.Format("{0} {1} {2} {3}", ChildNum, OrgTemp, RstrTemp, ReasonTemp) & System.Environment.NewLine
                                        Else
                                            Subject += String.Format("{0} {1} {2}", ChildNum, OrgTemp, RstrTemp) & System.Environment.NewLine
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    Next
                    Erase ChildList
                End If
                ChildList = Me.RGdata.GetUserList(Issuer)
                If ChildList IsNot Nothing Then
                    For j As Integer = 0 To ChildList.Length - 1 Step 1
                        Dim ChildNum As Long = ChildList(j)
                        If ChildNum > 0 Then
                            Dim BeforeTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            Dim AfterTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            If (BeforeTemp <= Me.DateTimePickerThisUpdate.Value) And (Me.DateTimePickerThisUpdate.Value <= AfterTemp) Then
                                Dim RstrTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                                If Not String.IsNullOrEmpty(RstrTemp) Then
                                    Dim RevoTemp As Date = Date.Parse(RstrTemp)
                                    If RevoTemp <= Me.DateTimePickerThisUpdate.Value Then
                                        Dim NameTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname)
                                        Dim ReasonTemp As String
                                        Dim RCodeTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                                        If Not String.IsNullOrEmpty(RCodeTemp) Then
                                            If RCodeTemp = "1" Then
                                                ReasonTemp = "所有者・サーバーの秘密鍵が紛失・盗難などにより信頼性が失墜したため"
                                            ElseIf RCodeTemp = "2" Then
                                                ReasonTemp = "認証局の秘密鍵が紛失・盗難などにより信頼性が失墜したため"
                                            ElseIf RCodeTemp = "3" Then
                                                ReasonTemp = "所有者・サーバーの内容（部署・名前など）に変更があったため"
                                            ElseIf RCodeTemp = "4" Then
                                                ReasonTemp = "内容の変更をともなわない証明書の交換"
                                            ElseIf RCodeTemp = "5" Then
                                                ReasonTemp = "所有者の退職・サービスの終了などにより証明書が不要となった"
                                            Else
                                                ReasonTemp = "その他"
                                            End If
                                            Subject += String.Format("{0} {1} {2} {3}", ChildNum, NameTemp, RstrTemp, ReasonTemp) & System.Environment.NewLine
                                        Else
                                            Subject += String.Format("{0} {1} {2}", ChildNum, NameTemp, RstrTemp) & System.Environment.NewLine
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    Next
                    Erase ChildList
                End If
                ChildList = Me.RGdata.GetServerList(Issuer)
                If ChildList IsNot Nothing Then
                    For j As Integer = 0 To ChildList.Length - 1 Step 1
                        Dim ChildNum As Long = ChildList(j)
                        If ChildNum > 0 Then
                            Dim BeforeTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            Dim AfterTemp As Date = Date.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            If (BeforeTemp <= Me.DateTimePickerThisUpdate.Value) And (Me.DateTimePickerThisUpdate.Value <= AfterTemp) Then
                                Dim RstrTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                                If Not String.IsNullOrEmpty(RstrTemp) Then
                                    Dim RevoTemp As Date = Date.Parse(RstrTemp)
                                    If RevoTemp <= Me.DateTimePickerThisUpdate.Value Then
                                        Dim NameTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname)
                                        Dim ReasonTemp As String
                                        Dim RCodeTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                                        If Not String.IsNullOrEmpty(RCodeTemp) Then
                                            If RCodeTemp = "1" Then
                                                ReasonTemp = "所有者・サーバーの秘密鍵が紛失・盗難などにより信頼性が失墜したため"
                                            ElseIf RCodeTemp = "2" Then
                                                ReasonTemp = "認証局の秘密鍵が紛失・盗難などにより信頼性が失墜したため"
                                            ElseIf RCodeTemp = "3" Then
                                                ReasonTemp = "所有者・サーバーの内容（部署・名前など）に変更があったため"
                                            ElseIf RCodeTemp = "4" Then
                                                ReasonTemp = "内容の変更をともなわない証明書の交換"
                                            ElseIf RCodeTemp = "5" Then
                                                ReasonTemp = "所有者の退職・サービスの終了などにより証明書が不要となった"
                                            Else
                                                ReasonTemp = "その他"
                                            End If
                                            Subject += String.Format("{0} {1} {2} {3}", ChildNum, NameTemp, RstrTemp, ReasonTemp) & System.Environment.NewLine
                                        Else
                                            Subject += String.Format("{0} {1} {2}", ChildNum, NameTemp, RstrTemp) & System.Environment.NewLine
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    Next
                    Erase ChildList
                End If
                Me.TextBoxSubject.Text = Subject
            End If
        End If
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateX509crl10.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel2_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel2.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateX509crl11.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel3_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel3.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateX509crl40.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel4_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel4.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateX509crl41.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel5_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel5.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "CreateX509crl42.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub
End Class