﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class CreateX509crl03
    Public RGdata As RegistData
    Public K9piaExecDirectory As String
    Public K9piaExecName As String
    Public K9piaCertDirectoryBase As String
    Public SerialNumber As Long
    Public Issuer As Long
    Public ThisUpdate As Date
    Public NextUpdate As Date
    Public CheckOk As Boolean
    Public RetCode As Integer
    Private BreakFlag As Boolean
    Private LOGdata As LogFile

    Private Sub CreateX509crl03_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 失効リストの実行画面クラスが作成されました。")
        Me.CheckOk = False                                             ' コンストラクタ：初期化します
        Me.RetCode = -1
        Me.LabelCreateEnd.ForeColor = SystemColors.Control             ' 完了メッセージを背景色と同じにして見えなくさせます
        Me.LabelRegistEnd.ForeColor = SystemColors.Control
        Me.LabelAllEnd.ForeColor = SystemColors.Control
        Me.BreakFlag = False
        Me.LOGdata = New LogFile()
    End Sub

    Private Sub CreateX509crl03_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 失効リストの実行画面クラスが表示されました。")
        Me.BackgroundWorker1.RunWorkerAsync()                          ' 表示と同時にバックグラウンド処理を開始します
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 失効リストの実行画面で〔キャンセル〕が押されました。")
        Me.CheckOk = False                                             ' キャンセル処理です
        Me.BreakFlag = True
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Debug.WriteLine("debug 失効リストのバックグラウンド処理を開始します。")
        Dim K9pia As k9piaCrlIssue = New k9piaCrlIssue                 ' バックグラウンド処理です
        Dim SNdirectory As String
        If Me.Issuer < 10000 Then
            SNdirectory = Me.Issuer.ToString("D4")
        ElseIf Me.Issuer < 100000000 Then
            SNdirectory = Me.Issuer.ToString("D8")
        Else
            SNdirectory = Me.Issuer.ToString("D64")
        End If                                                         ' 発行局(k9pia)との接続を開始します
        Dim CheckDir As DirectoryInfo = New DirectoryInfo(Me.K9piaCertDirectoryBase)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & "を作成しました。")
        End If
        CheckDir = New DirectoryInfo(Me.K9piaCertDirectoryBase + SNdirectory)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & SNdirectory & "を作成しました。")
        End If
        K9pia.K9piaExecDirectory = Me.K9piaExecDirectory
        K9pia.K9piaExecName = Me.K9piaExecName
        K9pia.SerialNumber = Me.SerialNumber
        K9pia.Issuer = Me.Issuer
        K9pia.ThisUpdate = Me.ThisUpdate
        K9pia.NextUpdate = Me.NextUpdate
        K9pia.CrlFilename = Me.K9piaCertDirectoryBase & SNdirectory & "/" & Me.Issuer.ToString()
        K9pia.CrlFilename += "_" & Me.ThisUpdate.ToString("yyyyMMdd") & ".crl"
        If Not Me.BreakFlag Then
            Me.RetCode = K9pia.sendCommand()                           ' 発行局に失効リスト作成を指示します
            Debug.WriteLine("debug 発行局もどり値 [" & Me.RetCode.ToString() & "]")
            Me.LOGdata.Logout("--------------------------------------------------------------------------------")
            If Me.RetCode = 0 Then
                Me.LOGdata.Logout("失効リストを発行しました。")
            Else
                Me.LOGdata.Logout("失効リストの発行に失敗しました。")
            End If
        Else
            Me.RetCode = -3
            Me.LOGdata.Logout("失効リストの発行がキャンセルされました。")
        End If
        If Me.RetCode = 0 Then
            Me.RetCode = -2                                            ' 終了コードを変更して処理を続けます
            Me.LabelCreateEnd.ForeColor = SystemColors.ControlText     ' 完了メッセージを黒にして見えるようにします
            RGdata.StackString(CommonDefines.RecordVersion, "V2") ' 登録情報ファイルに書き込みます
            RGdata.StackLong(CommonDefines.RecordSirinumber, Me.SerialNumber)
            RGdata.StackLong(CommonDefines.RecordIssuer, Me.Issuer)
            Dim AlgoTemp As String = Me.RGdata.GetString(Me.Issuer, CommonDefines.RecordSignalgo)
            RGdata.StackString(CommonDefines.RecordSignalgo, AlgoTemp)
            RGdata.StackString(CommonDefines.RecordThisUpdate, DateTime.Parse(Me.ThisUpdate.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.StackString(CommonDefines.RecordNextUpdate, DateTime.Parse(Me.NextUpdate.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.SetupCurrentType(CommonDefines.BlockCRL)
            If Not Me.BreakFlag Then
                RGdata.WriteStack()
                Me.LabelRegistEnd.ForeColor = SystemColors.ControlText ' 完了メッセージを黒にして見えるようにします
                Me.LabelAllEnd.ForeColor = SystemColors.ControlText
                Me.CheckOk = True                                      ' 終了コードに正常終了を設定します
                Me.RetCode = 0                                         ' 完了メッセージ確認のためにちょっと待ち
                System.Threading.Thread.Sleep(CommonDefines.MessageDilayTime)
                Me.LOGdata.Logout("失効リストを登録しました。")
            Else
                RGdata.CancelStack()
                Me.RetCode = -3
                Me.LOGdata.Logout("失効リストの登録がキャンセルされました。。")
            End If
        Else
            Me.LabelRegistEnd.Text = "… 失敗しました"                 ' 発行局でエラーの場合
            Me.LabelRegistEnd.ForeColor = SystemColors.ControlText
        End If                                                         ' 続けてバックグラウンド処理の終了イベントに移ります
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Debug.WriteLine("debug バックグラウンド処理の終了値 [" & Me.RetCode.ToString() & "]")
        If Me.RetCode <> 0 Then                                        ' バックグラウンド処理の終了イベントです
            Dim msg As String = "失効リストの作成が失敗しました。"     ' エラーがあれば、ここでメッセージを表示します
            msg &= "エラーコード：" & Me.RetCode.ToString()
            If Me.RetCode = CommonDefines.ErrorCodeK9piaKeys Then
                msg &= " 再実行によりエラーが解消する場合があります。"
            ElseIf Me.RetCode = CommonDefines.ErrorCodeK9piaMakefile Then
                msg &= " フォルダの書き込み権限を確認してください。"
            End If
            MessageBox.Show(msg, "作成の失敗", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.CheckOk = False
        End If
        Me.Close()                                                     ' 画面を閉じます
    End Sub
End Class