﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Security.Cryptography.X509Certificates

Public Class ImportCertMiddle01
    Public RGdata As RegistData
    Public CheckOk As Boolean
    Public DirectoryName As String
    Public FileName As String
    Public FileExtend As String
    Public KeyExist As Boolean
    Public SerialNumber As Long

    Private Sub ImportCertMiddle01_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 認証局インポートの入力画面クラスが作成されました。")
        Me.TextBoxVersion.Text = "-"
        Me.TextBoxSerialNumber.Text = "-"
        Me.TextBoxSignatureAlgorithm.Text = "-"
        Me.TextBoxIssuer.Text = "-"
        Me.TextBoxNotBefore.Text = "-"
        Me.TextBoxNotAfter.Text = "-"
        Me.TextBoxCountryName.Text = "-"
        Me.TextBoxStateOrProvinceName.Text = "-"
        Me.TextBoxLocalityName.Text = "-"
        Me.TextBoxOrganizationName.Text = "-"
        Me.TextBoxOrganizationUnitName.Text = "-"
        Me.TextBoxCommonName.Text = "-"
        Me.TextBoxBasicConstraints.Text = "-"
        Me.TextBoxPathlen.Text = "-"
        Me.TextBoxCertificatePolicies.Text = "-"
        Me.TextBoxPolicyOID.Text = "-"
        Me.TextBoxCRLDistributionPoints.Text = "-"
        Me.TextBoxAuthorityInfoAccess.Text = "-"
        Me.TextBoxKeysize.Text = "-"
        Me.LabelSubject.ForeColor = SystemColors.Control
        Me.Labelextensions.ForeColor = SystemColors.Control
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 認証局インポートの入力画面を閉じます。")
        Me.CheckOk = False
        Me.Close()
    End Sub

    Private Sub ButtonOK_Click(sender As Object, e As EventArgs) Handles ButtonOK.Click
        Debug.WriteLine("debug 認証局インポートの入力画面を閉じます。")
        Me.CheckOk = True
        Me.Close()
    End Sub

    Private Sub ButtonCertificate_Click(sender As Object, e As EventArgs) Handles ButtonCertificate.Click
        Dim CerFile As OpenFileDialog = New OpenFileDialog()           ' 選択ボタンをクリックされたときの処理です
        CerFile.Filter = "Certificate files (*.cer)|*.cer|PKCS#12 files (*.p12;*.pfx)|*.p12;*.pfx|All files (*.*)|*.*"
        CerFile.FilterIndex = 1                                        ' 証明書の選択ダイアログを表示します
        If CerFile.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim FileTemp As System.IO.FileInfo = New System.IO.FileInfo(CerFile.FileName)
            Me.DirectoryName = FileTemp.DirectoryName
            Dim TempExtend As String() = FileTemp.Name.Split(".")
            If TempExtend.Length = 2 Then
                Me.FileName = TempExtend(0)
                If TempExtend(1).ToLower() = CommonDefines.K9extCER Then
                    Me.FileExtend = TempExtend(1)
                    Me.TextBoxFilename.Text = FileTemp.FullName
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.Enabled = False
                    Me.ButtonImport.Enabled = False
                    Try
                        Dim CertTemp As X509Certificate2 = New X509Certificate2(FileTemp.FullName)
                        Me.CertAnalyze(CertTemp)
                        Dim KeyFileName As String = Me.DirectoryName + "/" + Me.FileName + "." + CommonDefines.K9extKEY
                        Dim KeyCheck As FileInfo = New FileInfo(KeyFileName)
                        If KeyCheck.Exists Then
                            Me.KeyExist = True
                        Else
                            Me.KeyExist = False
                            Dim Msg As String = "警告：この証明書に対応する秘密鍵が見つかりません。"
                            MessageBox.Show(Msg)
                        End If
                    Catch ex As Exception
                        Dim msg As String = "証明書の読み込みに失敗しました。"
                        msg &= ex.Message
                        MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Me.FileExtend = ""
                        Me.TextBoxFilename.Text = ""
                        Me.TextBoxPassword.Text = ""
                        Me.TextBoxPassword.Enabled = False
                        Me.ButtonImport.Enabled = False
                        Me.SerialNumber = 0
                        Me.ButtonOK.Enabled = False
                    End Try
                ElseIf (TempExtend(1).ToLower() = CommonDefines.K9extP12) Or (TempExtend(1).ToLower() = CommonDefines.K9extPFX) Then
                    Me.FileExtend = TempExtend(1)
                    Me.TextBoxFilename.Text = FileTemp.FullName
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.ReadOnly = False
                    Me.TextBoxPassword.Enabled = True
                    Me.ButtonImport.Enabled = True
                    Me.SerialNumber = 0
                    Me.ButtonOK.Enabled = False
                Else
                    Dim msg As String = "ファイル形式が判断できません。"
                    msg &= "拡張子は cer｜p12｜pfx のいずれかにしてください。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.FileExtend = ""
                    Me.TextBoxFilename.Text = ""
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.Enabled = False
                    Me.ButtonImport.Enabled = False
                    Me.SerialNumber = 0
                    Me.ButtonOK.Enabled = False
                End If
            Else
                Dim msg As String = "ファイル形式が判断できません。"
                msg &= "拡張子が無いか、二重拡張子になっています。"
                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.FileExtend = ""
                Me.TextBoxFilename.Text = ""
                Me.TextBoxPassword.Text = ""
                Me.TextBoxPassword.Enabled = False
                Me.ButtonImport.Enabled = False
                Me.SerialNumber = 0
                Me.ButtonOK.Enabled = False
            End If
        End If
    End Sub

    Private Sub ButtonImport_Click(sender As Object, e As EventArgs) Handles ButtonImport.Click
        Try
            Dim CertTemp As X509Certificate2 = New X509Certificate2(Me.TextBoxFilename.Text, Me.TextBoxPassword.Text)
            Me.CertAnalyze(CertTemp)
            Me.KeyExist = True
        Catch ex As Exception
            Dim msg As String = "証明書の読み込みに失敗しました。"
            msg &= ex.Message
            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.FileExtend = ""
            Me.SerialNumber = 0
            Me.ButtonOK.Enabled = False
        End Try
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "ImportCertMiddle10.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel2_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel2.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "ImportCertMiddle12.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel3_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel3.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "ImportCertMiddle32.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub CertAnalyze(ByRef CertTemp As X509Certificate2)
        Dim LogMessage As LogFile = New LogFile()
        Me.TextBoxVersion.Text = "V" & CertTemp.Version.ToString()
        Me.TextBoxSerialNumber.Text = CertTemp.SerialNumber
        Me.TextBoxSignatureAlgorithm.Text = CertTemp.SignatureAlgorithm.FriendlyName
        Me.TextBoxIssuer.Text = CertTemp.Issuer
        Me.TextBoxNotBefore.Text = CertTemp.NotBefore.AddHours(-9).ToString("yyyy/MM/dd HH:mm:ss")
        Me.TextBoxNotAfter.Text = CertTemp.NotAfter.AddHours(-9).ToString("yyyy/MM/dd HH:mm:ss")
        Me.LabelSubject.ForeColor = SystemColors.Control
        Me.TextBoxCountryName.Text = "-"
        Me.TextBoxStateOrProvinceName.Text = "-"
        Me.TextBoxLocalityName.Text = "-"
        Me.TextBoxOrganizationName.Text = "-"
        Me.TextBoxOrganizationUnitName.Text = "-"
        Me.TextBoxCommonName.Text = "-"
        Dim SubjectTemp As String = CertTemp.SubjectName.Name
        Dim ItemTemp As String = ""
        Dim ValueTemp As String = ""
        Dim InMode As String = "item"
        For i As Integer = 0 To SubjectTemp.Length - 1 Step 1
            If SubjectTemp.Substring(i, 1) = """" Then
                If InMode = "quotation" Then
                    InMode = "value"
                Else
                    InMode = "quotation"
                End If
            ElseIf SubjectTemp.Substring(i, 1) = "," Then
                If InMode = "quotation" Then
                    ValueTemp += SubjectTemp.Substring(i, 1)
                Else
                    If ItemTemp = "C" Then
                        Me.TextBoxCountryName.Text = ValueTemp
                    ElseIf ItemTemp = "S" Then
                        Me.TextBoxStateOrProvinceName.Text = ValueTemp
                    ElseIf ItemTemp = "L" Then
                        Me.TextBoxLocalityName.Text = ValueTemp
                    ElseIf ItemTemp = "O" Then
                        Me.TextBoxOrganizationName.Text = ValueTemp
                    ElseIf ItemTemp = "OU" Then
                        Me.TextBoxOrganizationUnitName.Text = ValueTemp
                    ElseIf ItemTemp = "CN" Then
                        Me.TextBoxCommonName.Text = ValueTemp
                    Else
                        Me.LabelSubject.ForeColor = Color.Red
                        Dim Msg As String = "所有者（サブジェクト）の「"
                        Msg &= ItemTemp & "=" & ValueTemp & "」はインポートされません。"
                        LogMessage.Logout(Msg)
                    End If
                    InMode = "item"
                    ItemTemp = ""
                    ValueTemp = ""
                End If
            ElseIf SubjectTemp.Substring(i, 1) = "=" Then
                If InMode = "item" Then
                    InMode = "value"
                Else
                    ValueTemp += SubjectTemp.Substring(i, 1)
                End If
            Else
                If InMode = "item" Then
                    If SubjectTemp.Substring(i, 1) <> " " Then
                        ItemTemp += SubjectTemp.Substring(i, 1)
                    End If
                Else
                    ValueTemp += SubjectTemp.Substring(i, 1)
                End If
            End If
        Next
        If ItemTemp = "C" Then
            Me.TextBoxCountryName.Text = ValueTemp
        ElseIf ItemTemp = "S" Then
            Me.TextBoxStateOrProvinceName.Text = ValueTemp
        ElseIf ItemTemp = "L" Then
            Me.TextBoxLocalityName.Text = ValueTemp
        ElseIf ItemTemp = "O" Then
            Me.TextBoxOrganizationName.Text = ValueTemp
        ElseIf ItemTemp = "OU" Then
            Me.TextBoxOrganizationUnitName.Text = ValueTemp
        ElseIf ItemTemp = "CN" Then
            Me.TextBoxCommonName.Text = ValueTemp
        Else
            Me.LabelSubject.ForeColor = Color.Red
            Dim Msg As String = "所有者（サブジェクト）の「"
            Msg &= ItemTemp & "=" & ValueTemp & "」はインポートされません。"
            LogMessage.Logout(Msg)
        End If
        Me.Labelextensions.ForeColor = SystemColors.Control
        Me.TextBoxBasicConstraints.Text = "-"
        Me.TextBoxPathlen.Text = "-"
        Me.TextBoxCertificatePolicies.Text = "-"
        Me.TextBoxPolicyOID.Text = "-"
        Me.TextBoxCRLDistributionPoints.Text = "-"
        Me.TextBoxAuthorityInfoAccess.Text = "-"
        Dim ExCollTemp As X509ExtensionCollection = CertTemp.Extensions
        For i As Integer = 0 To ExCollTemp.Count - 1 Step 1
            If ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDbasicCnst Then
                Dim ExTemp As ASN1analyze = New ASN1analyze()
                ExTemp.RunAnalyze(ExCollTemp.Item(i).RawData)
                Dim CaFlag As ASN1analyze = ExTemp.ChildElement(0)
                If CaFlag.MyData(0) <> 0 Then
                    Me.TextBoxBasicConstraints.Text = "認証局"
                Else
                    Me.TextBoxBasicConstraints.Text = "エンドエンティティ証明書"
                End If
                If ExTemp.ChildCount = 2 Then
                    Dim PathLen As ASN1analyze = ExTemp.ChildElement(1)
                    Me.TextBoxPathlen.Text = PathLen.GetInt64().ToString()
                End If
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDpolices Then
                Dim ExTemp As ASN1analyze = New ASN1analyze()
                ExTemp.RunAnalyze(ExCollTemp.Item(i).RawData)
                Dim PolcOID As ASN1analyze = ExTemp.ChildElement(0).ChildElement(0)
                If PolcOID.GetOID() = CommonDefines.OIDpoliceAny Then
                    Me.TextBoxPolicyOID.Text = CommonDefines.K9anyP
                Else
                    Me.TextBoxPolicyOID.Text = PolcOID.GetOID()
                End If
                Dim Polices As ASN1analyze = ExTemp.ChildElement(0).ChildElement(1).ChildElement(0).ChildElement(0)
                If Polices.GetOID() = CommonDefines.OIDpoliceMsg Then
                    Dim UniTemp As System.Text.UnicodeEncoding = New UnicodeEncoding(True, True)
                    Dim ChrTemp As Char() = UniTemp.GetChars(ExTemp.ChildElement(0).ChildElement(1).ChildElement(0).ChildElement(1).ChildElement(0).MyData)
                    Me.TextBoxCertificatePolicies.Text = Convert.ToString(ChrTemp)
                Else
                    Me.TextBoxCertificatePolicies.Text = ExTemp.ChildElement(0).ChildElement(1).ChildElement(0).ChildElement(1).GetText()
                End If
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDcrlPoint Then
                Dim ExTemp As ASN1analyze = New ASN1analyze()
                ExTemp.RunAnalyze(ExCollTemp.Item(i).RawData)
                Dim CrlDpTemp As String = ExTemp.ChildElement(0).ChildElement(0).ChildElement(0).ChildElement(0).GetText()
                If CrlDpTemp.Substring(0, 4) = "http" Then
                    Me.TextBoxCRLDistributionPoints.Text = CrlDpTemp
                Else
                    Dim Msg As String = "CRL配布ポイントが規定外なのでインポートされません。"
                    LogMessage.Logout(Msg)
                End If
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDauthInfo Then
                Dim ExTemp As ASN1analyze = New ASN1analyze()
                ExTemp.RunAnalyze(ExCollTemp.Item(i).RawData)
                Me.TextBoxAuthorityInfoAccess.Text = ExTemp.ChildElement(0).ChildElement(1).GetText()
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDsubKeyID Then
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "(subjectKeyIdentifier)」はインポートされません。"
                LogMessage.Logout(Msg)
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDathKeyID Then
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "(authorityKeyIdentifier)」はインポートされません。"
                LogMessage.Logout(Msg)
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDkeyUsage Then
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "(keyUsage)」はインポートされません。"
                LogMessage.Logout(Msg)
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDsubAltNm Then
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "(subjectAltName)」はインポートされません。"
                LogMessage.Logout(Msg)
            ElseIf ExCollTemp.Item(i).Oid.Value = CommonDefines.OIDisuAltNm Then
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "(issuerAltName)」はインポートされません。"
                LogMessage.Logout(Msg)
            Else
                Me.Labelextensions.ForeColor = Color.Red
                Dim Msg As String = "拡張領域の「"
                Msg &= "OID=" & ExCollTemp.Item(i).Oid.Value & "」はインポートされません。"
                LogMessage.Logout(Msg)
            End If
        Next
        Me.TextBoxKeysize.Text = CertTemp.PublicKey.Key.KeySize.ToString()

        Try
            Dim SnTemp As Long = Convert.ToInt64(CertTemp.SerialNumber, 16)
            If SnTemp > 0 Then
                Dim CnTemp As String = Me.RGdata.GetString(SnTemp, CommonDefines.RecordComname)
                If Not String.IsNullOrEmpty(CnTemp) Then
                    Dim msg As String = "証明書のシリアル番号が重複しています。"
                    msg &= "この証明書はインポートできません。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.FileExtend = ""
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.Enabled = False
                    Me.ButtonImport.Enabled = False
                    Me.SerialNumber = 0
                    Me.ButtonOK.Enabled = False
                ElseIf (DateTime.Now < CertTemp.NotBefore.AddHours(-9)) Or (CertTemp.NotAfter.AddHours(-9) < DateTime.Now) Then
                    Dim msg As String = "証明書が期限前か期限を過ぎています。"
                    msg &= "この証明書はインポートできません。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.FileExtend = ""
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.Enabled = False
                    Me.ButtonImport.Enabled = False
                    Me.SerialNumber = 0
                    Me.ButtonOK.Enabled = False
                ElseIf (Me.TextBoxCountryName.Text = "-") Or (Me.TextBoxOrganizationName.Text = "-") Or (Me.TextBoxCommonName.Text = "-") Then
                    Dim msg As String = "証明書の必須項目が記載されていません。"
                    msg &= "この証明書はインポートできません。"
                    MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.FileExtend = ""
                    Me.TextBoxPassword.Text = ""
                    Me.TextBoxPassword.Enabled = False
                    Me.ButtonImport.Enabled = False
                    Me.SerialNumber = 0
                    Me.ButtonOK.Enabled = False
                Else
                    Me.SerialNumber = SnTemp
                    Me.ButtonOK.Enabled = True
                End If
            Else
                Dim msg As String = "証明書のシリアル番号が制限値を超えています。"
                msg &= "この証明書はインポートできません。"
                MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.FileExtend = ""
                Me.TextBoxPassword.Text = ""
                Me.TextBoxPassword.Enabled = False
                Me.ButtonImport.Enabled = False
                Me.SerialNumber = 0
                Me.ButtonOK.Enabled = False
            End If
        Catch ex As Exception
            Dim msg As String = "証明書のシリアル番号が制限値を超えています。"
            msg &= "この証明書はインポートできません。"
            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.FileExtend = ""
            Me.TextBoxPassword.Text = ""
            Me.TextBoxPassword.Enabled = False
            Me.ButtonImport.Enabled = False
            Me.SerialNumber = 0
            Me.ButtonOK.Enabled = False
        End Try
    End Sub
End Class