﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class ImportCertMiddle03
    Public RGdata As RegistData
    Public K9piaExecDirectory As String
    Public K9piaExecName As String
    Public K9piaCertDirectoryBase As String
    Public DirectoryName As String
    Public FileName As String
    Public FileExtend As String
    Public Password As String
    Public KeyExist As Boolean
    Public SerialNumber As Long
    Public CountryName As String
    Public StateOrProvinceName As String
    Public LocalityName As String
    Public OrganizationName As String
    Public OrganizationUnitName As String
    Public CommonName As String
    Public NotBefore As Date
    Public NotAfter As Date
    Public BasicConst As Boolean
    Public Pathlen As Integer
    Public CertificatePolicies As String
    Public AnyPolicyUsed As Boolean
    Public PolicyOID As String
    Public CRLDistributionPoints As String
    Public AuthorityInfoAccess As String
    Public Keysize As Integer
    Public SignAlgo As String
    Public CheckOk As Boolean
    Public RetCode As Integer
    Private BreakFlag As Boolean
    Private LOGdata As LogFile

    Private Sub ImportCertMiddle03_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 認証局インポートの実行画面クラスが作成されました。")
        Me.CheckOk = False                                             ' コンストラクタ：初期化します
        Me.RetCode = -1
        Me.LabelCreateEnd.ForeColor = SystemColors.Control             ' 完了メッセージを背景色と同じにして見えなくさせます
        Me.LabelRegistEnd.ForeColor = SystemColors.Control
        Me.LabelAllEnd.ForeColor = SystemColors.Control
        Me.BreakFlag = False
        Me.LOGdata = New LogFile()
    End Sub

    Private Sub ImportCertMiddle03_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 認証局インポートの実行画面クラスが表示されました。")
        Me.BackgroundWorker1.RunWorkerAsync()                          ' 表示と同時にバックグラウンド処理を開始します
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 認証局インポートの実行画面で〔キャンセル〕が押されました。")
        Me.CheckOk = False                                             ' キャンセル処理です
        Me.BreakFlag = True
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Debug.WriteLine("debug 認証局インポートのバックグラウンド処理を開始します。")
        Dim NewFile As String
        Dim NewFileExt As String
        Dim K9pia As k9piaCertImport = New k9piaCertImport          ' バックグラウンド処理です
        Dim SNdirectory As String
        If Me.SerialNumber < 10000 Then
            SNdirectory = Me.SerialNumber.ToString("D4")
        ElseIf Me.SerialNumber < 100000000 Then
            SNdirectory = Me.SerialNumber.ToString("D8")
        Else
            SNdirectory = Me.SerialNumber.ToString("D64")
        End If
        Dim CheckDir As DirectoryInfo = New DirectoryInfo(Me.K9piaCertDirectoryBase)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & "を作成しました。")
        End If
        CheckDir = New DirectoryInfo(Me.K9piaCertDirectoryBase + SNdirectory)
        If Not CheckDir.Exists Then
            CheckDir.Create()
            Debug.WriteLine("ディレクトリ" & Me.K9piaCertDirectoryBase & SNdirectory & "を作成しました。")
        End If
        If Me.FileExtend.ToLower() = CommonDefines.K9extCER Then
            Dim OldFile As String = Me.DirectoryName & "/" & Me.FileName & "." & Me.FileExtend
            NewFile = Me.K9piaCertDirectoryBase & SNdirectory & "/" & Me.SerialNumber.ToString()
            NewFileExt = CommonDefines.K9extCER
            Dim FileTemp As System.IO.FileInfo = New System.IO.FileInfo(OldFile)
            FileTemp.CopyTo((NewFile & "." & NewFileExt), True)
            Debug.WriteLine("ファイル" & OldFile & "を" & NewFile & "へコピーしました。")
            If Me.KeyExist Then
                OldFile = Me.DirectoryName & "/" & Me.FileName & "." & CommonDefines.K9extKEY
                FileTemp = New System.IO.FileInfo(OldFile)
                FileTemp.CopyTo((NewFile & "." & CommonDefines.K9extKEY), True)
                Debug.WriteLine("ファイル" & OldFile & "を" & NewFile & "へコピーしました。")
            End If
        Else
            Dim OldFile As String = Me.DirectoryName & "/" & Me.FileName & "." & Me.FileExtend
            NewFile = Me.K9piaCertDirectoryBase & SNdirectory & "/" & Me.SerialNumber.ToString()
            NewFileExt = CommonDefines.K9extPFX
            Dim FileTemp As System.IO.FileInfo = New System.IO.FileInfo(OldFile)
            FileTemp.CopyTo((NewFile & "." & NewFileExt), True)
            Debug.WriteLine("ファイル" & OldFile & "を" & NewFile & "へコピーしました。")
        End If

        K9pia.K9piaExecDirectory = Me.K9piaExecDirectory
        K9pia.K9piaExecName = Me.K9piaExecName
        K9pia.CertFilename = NewFile                                   ' 拡張子が小文字じゃないと困るんで
        K9pia.CertExtend = NewFileExt                                  ' コピー後のファイルをインポートします
        If (Not String.IsNullOrEmpty(Me.Password)) And (Me.Password <> "-") Then
            K9pia.CertPassword = Me.Password
        Else
            K9pia.CertPassword = Nothing
        End If
        If (NewFileExt <> CommonDefines.K9extCER) Or Me.KeyExist Then
            K9pia.JPKIused = False
        Else
            K9pia.JPKIused = True
        End If
        If Not Me.BreakFlag Then
            Me.RetCode = K9pia.sendCommand()                           ' 発行局に認証局証明書インポートを指示します
            Debug.WriteLine("debug 発行局もどり値 [" & Me.RetCode.ToString() & "]")
            Me.LOGdata.Logout("--------------------------------------------------------------------------------")
            If Me.RetCode = 0 Then
                Me.LOGdata.Logout("証明書をインポートしました。")
            Else
                Me.LOGdata.Logout("証明書のインポートに失敗しました。")
            End If
        Else
            Me.RetCode = -3
            Me.LOGdata.Logout("証明書のインポートがキャンセルされました。")
        End If
        If Me.RetCode = 0 Then
            Me.RetCode = -2                                            ' 終了コードを変更して処理を続けます
            Me.LabelCreateEnd.ForeColor = SystemColors.ControlText     ' 完了メッセージを黒にして見えるようにします
            RGdata.StackString(CommonDefines.RecordVersion, CommonDefines.K9certVer) ' 登録情報ファイルに書き込みます
            RGdata.StackLong(CommonDefines.RecordSirinumber, Me.SerialNumber)
            RGdata.StackString(CommonDefines.RecordSignalgo, Me.SignAlgo)
            RGdata.StackString(CommonDefines.RecordNotbefore, DateTime.Parse(Me.NotBefore.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.StackString(CommonDefines.RecordNotafter, DateTime.Parse(Me.NotAfter.ToString("yyyy/MM/dd 00:00:00")))
            RGdata.StackString(CommonDefines.RecordTimezone, CommonDefines.TimeZoneJST)
            RGdata.StackString(CommonDefines.RecordContry, Me.CountryName)
            If Not String.IsNullOrEmpty(Me.StateOrProvinceName) Then
                RGdata.StackString(CommonDefines.RecordStateprov, Me.StateOrProvinceName)
            End If
            If Not String.IsNullOrEmpty(Me.LocalityName) Then
                RGdata.StackString(CommonDefines.RecordLocality, Me.LocalityName)
            End If
            RGdata.StackString(CommonDefines.RecordOrganiz, Me.OrganizationName)
            If Not String.IsNullOrEmpty(Me.OrganizationUnitName) Then
                RGdata.StackString(CommonDefines.RecordOrganizUnit, Me.OrganizationUnitName)
            End If
            RGdata.StackString(CommonDefines.RecordComname, Me.CommonName)
            If Me.BasicConst Then
                RGdata.StackLong(CommonDefines.RecordBccae, 1)
                RGdata.StackLong(CommonDefines.RecordBcpath, Me.Pathlen)
            Else
                RGdata.StackLong(CommonDefines.RecordBccae, 0)
            End If
            If Not String.IsNullOrEmpty(Me.CertificatePolicies) Then
                RGdata.StackString(CommonDefines.RecordCpUri, Me.CertificatePolicies)
                If Me.AnyPolicyUsed Then
                    RGdata.StackString(CommonDefines.RecordCpOID, CommonDefines.K9anyP)
                Else
                    RGdata.StackString(CommonDefines.RecordCpOID, Me.PolicyOID)
                End If
            End If
            If Not String.IsNullOrEmpty(Me.CRLDistributionPoints) Then
                RGdata.StackString(CommonDefines.RecordCRLdpUrl, Me.CRLDistributionPoints)
            End If
            If Not String.IsNullOrEmpty(Me.AuthorityInfoAccess) Then
                RGdata.StackString(CommonDefines.RecordAinfoCA, Me.AuthorityInfoAccess)
            End If
            If (NewFileExt <> CommonDefines.K9extCER) Or Me.KeyExist Then
                If Me.SignAlgo = CommonDefines.K9sha1 Then
                    RGdata.StackString(CommonDefines.RecordRSAproviderType, CommonDefines.K9cspDefType)
                    RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspDef)
                Else
                    Dim OStype As System.OperatingSystem = System.Environment.OSVersion
                    If (OStype.Platform = System.PlatformID.Win32NT) And (OStype.Version.Major = 5) And (OStype.Version.Minor = 1) Then
                        RGdata.StackString(CommonDefines.RecordRSAproviderType, CommonDefines.K9cspAXPType)
                        RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspAXP)
                    Else
                        RGdata.StackString(CommonDefines.RecordRSAproviderType, CommonDefines.K9cspAesType)
                        RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspAes)
                    End If
                End If
            Else
                RGdata.StackString(CommonDefines.RecordRSAproviderType, CommonDefines.K9cspJpkType)
                RGdata.StackString(CommonDefines.RecordCSPname, CommonDefines.K9cspJpk)
            End If
            RGdata.StackLong(CommonDefines.RecordKeysize, Me.Keysize)
            RGdata.SetupCurrentType(CommonDefines.BlockCA)
            If Not Me.BreakFlag Then
                RGdata.WriteStack()
                Me.LabelRegistEnd.ForeColor = SystemColors.ControlText ' 完了メッセージを黒にして見えるようにします
                Me.LabelAllEnd.ForeColor = SystemColors.ControlText
                Me.CheckOk = True                                      ' 終了コードに正常終了を設定します
                Me.RetCode = 0                                         ' 完了メッセージ確認のためにちょっと待ち
                System.Threading.Thread.Sleep(CommonDefines.MessageDilayTime)
                Me.LOGdata.Logout("インポートした証明書を登録しました。")
            Else
                RGdata.CancelStack()
                Me.RetCode = -3
                Me.LOGdata.Logout("インポートした証明書の登録がキャンセルされました。。")
            End If
        Else
            Me.LabelRegistEnd.Text = "… 失敗しました"                 ' 発行局でエラーの場合
            Me.LabelRegistEnd.ForeColor = SystemColors.ControlText
        End If                                                         ' 続けてバックグラウンド処理の終了イベントに移ります
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Debug.WriteLine("debug バックグラウンド処理の終了値 [" & Me.RetCode.ToString() & "]")
        If Me.RetCode <> 0 Then                                        ' バックグラウンド処理の終了イベントです
            Dim msg As String = "認証局のインポートが失敗しました。"   ' エラーがあれば、ここでメッセージを表示します
            msg &= "エラーコード：" & Me.RetCode.ToString()
            If Me.RetCode = CommonDefines.ErrorCodeK9piaKeys Then
                msg &= " 再実行によりエラーが解消する場合があります。"
            ElseIf Me.RetCode = CommonDefines.ErrorCodeK9piaMakefile Then
                msg &= " フォルダの書き込み権限を確認してください。"
            End If
            MessageBox.Show(msg, "インポートの失敗", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.CheckOk = False
        End If
        Me.Close()                                                     ' 画面を閉じます
    End Sub
End Class