﻿Public Class RevocateCert01
    Public CheckOk As Boolean
    Public RGdata As RegistData
    Public AuthList As AuthorityListBlock

    Private Sub RevocateCert01_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 証明書の失効の入力画面クラスが作成されました。")
        Me.CheckOk = False
        'Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
        'Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
        Me.DateTimePickerRevocateDate.Value = Date.Now
        Me.DateTimePickerRevocateDate.MinDate = Date.Now
        Me.ButtonOK.Enabled = False
    End Sub

    Private Sub RevocateCert01_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 証明書の失効の入力画面クラスが表示されました。")
        Me.AuthList = New AuthorityListBlock
        Me.AuthList.GetArray(Me.RGdata)
        If (Me.AuthList.Length > 0) Then
            Me.ComboBoxAuthority.ForeColor = System.Drawing.SystemColors.ControlText
            If Me.ComboBoxAuthority.Items.Count = 0 Then
                For i As Integer = 0 To Me.AuthList.Length - 1 Step 1
                    Dim NodeTitle As String = String.Format("{0} {1}", Me.AuthList.SerialNumber(i), Me.AuthList.Organization(i))
                    Me.ComboBoxAuthority.Items.Add(NodeTitle)
                Next
            Else
                Debug.WriteLine("debug 認証局が作成済みです。")
            End If
            Me.ComboBoxAuthority.Text = String.Format("{0} {1}", Me.AuthList.SerialNumber(0), Me.AuthList.Organization(0))
            Me.ComboBoxAuthority.ForeColor = SystemColors.ControlText
            Me.ButtonOK.Enabled = True
        Else
            Me.ComboBoxAuthority.Text = "選択できる認証局がありません"
            Me.ComboBoxAuthority.ForeColor = System.Drawing.Color.Red
        End If
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 証明書の失効の入力画面を閉じます。")
        Me.CheckOk = False
        Me.Close()
    End Sub

    Private Sub ButtonOK_Click(sender As Object, e As EventArgs) Handles ButtonOK.Click
        Debug.WriteLine("debug 入力内容を確認します。")
        Dim RevocateCount As Integer = 0
        If Me.ListView1.Items IsNot Nothing Then
            For i As Integer = 0 To Me.ListView1.Items.Count - 1 Step 1
                If Me.ListView1.Items.Item(i).Checked Then
                    If Me.ListView1.Items.Item(i).SubItems.Item(11).Text = "-" Then
                        RevocateCount += 1
                    End If
                End If
            Next
        End If
        If RevocateCount > 0 Then
            Debug.WriteLine("debug 入力は正しく行われています。")
            Me.CheckOk = True
            Me.Close()
        Else
            Dim msg As String = "有効な証明書が選択されていません。"
            msg &= "新たに失効させる証明書を選択してください。"
            MessageBox.Show(msg, "入力値エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub ComboBoxAuthority_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBoxAuthority.SelectedIndexChanged
        Debug.WriteLine("debug 証明書の一覧を表示します。")
        Dim AuthListID As Integer = Me.ComboBoxAuthority.SelectedIndex
        Dim Issuer As Long = Me.AuthList.SerialNumber(AuthListID)
        Me.ListView1.Items.Clear()
        Dim ChildList() As Long = Me.RGdata.GetMiddleList(Issuer)
        If ChildList IsNot Nothing Then
            For j As Integer = 0 To ChildList.Length - 1 Step 1
                Dim ChildNum As Long = ChildList(j)
                If ChildNum > 0 Then
                    Dim ItemTemp As ListViewItem = New ListViewItem(ChildNum.ToString())
                    ItemTemp.SubItems.Add("中間認証局")
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordContry))
                    Dim ColTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordStateprov)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordLocality)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganiz))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganizUnit)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        Dim ColTemp2 As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                        If Not String.IsNullOrEmpty(ColTemp2) Then
                            If ColTemp2 = "1" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "2" Then
                                ItemTemp.SubItems.Add("認証局の秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "3" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの内容（部署・名前など）に変更があったため")
                            ElseIf ColTemp2 = "4" Then
                                ItemTemp.SubItems.Add("内容の変更をともなわない証明書の交換")
                            ElseIf ColTemp2 = "5" Then
                                ItemTemp.SubItems.Add("所有者の退職・サービスの終了などにより証明書が不要となった")
                            Else
                                ItemTemp.SubItems.Add("その他")
                            End If
                        Else
                            ItemTemp.SubItems.Add("-")
                        End If
                        ItemTemp.SubItems.Add(ColTemp)
                        ItemTemp.ForeColor = Color.Silver
                    Else
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.ForeColor = SystemColors.ControlText
                    End If
                    Me.ListView1.Items.Add(ItemTemp)
                End If
            Next
            Erase ChildList
        End If
        ChildList = Me.RGdata.GetUserList(Issuer)
        If ChildList IsNot Nothing Then
            For j As Integer = 0 To ChildList.Length - 1 Step 1
                Dim ChildNum As Long = ChildList(j)
                If ChildNum > 0 Then
                    Dim ItemTemp As ListViewItem = New ListViewItem(ChildNum.ToString())
                    ItemTemp.SubItems.Add("個人証明書")
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordContry))
                    Dim ColTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordStateprov)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordLocality)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganiz))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganizUnit)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        Dim ColTemp2 As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                        If Not String.IsNullOrEmpty(ColTemp2) Then
                            If ColTemp2 = "1" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "2" Then
                                ItemTemp.SubItems.Add("認証局の秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "3" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの内容（部署・名前など）に変更があったため")
                            ElseIf ColTemp2 = "4" Then
                                ItemTemp.SubItems.Add("内容の変更をともなわない証明書の交換")
                            ElseIf ColTemp2 = "5" Then
                                ItemTemp.SubItems.Add("所有者の退職・サービスの終了などにより証明書が不要となった")
                            Else
                                ItemTemp.SubItems.Add("その他")
                            End If
                        Else
                            ItemTemp.SubItems.Add("-")
                        End If
                        ItemTemp.SubItems.Add(ColTemp)
                        ItemTemp.ForeColor = Color.Silver
                    Else
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.ForeColor = SystemColors.ControlText
                    End If
                    Me.ListView1.Items.Add(ItemTemp)
                End If
            Next
            Erase ChildList
        End If
        ChildList = Me.RGdata.GetServerList(Issuer)
        If ChildList IsNot Nothing Then
            For j As Integer = 0 To ChildList.Length - 1 Step 1
                Dim ChildNum As Long = ChildList(j)
                If ChildNum > 0 Then
                    Dim ItemTemp As ListViewItem = New ListViewItem(ChildNum.ToString())
                    ItemTemp.SubItems.Add("サーバー証明書")
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordContry))
                    Dim ColTemp As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordStateprov)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordLocality)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganiz))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganizUnit)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        ItemTemp.SubItems.Add(ColTemp)
                    Else
                        ItemTemp.SubItems.Add("-")
                    End If
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                    ItemTemp.SubItems.Add(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                    ColTemp = Me.RGdata.GetString(ChildNum, CommonDefines.RecordRevocate)
                    If Not String.IsNullOrEmpty(ColTemp) Then
                        Dim ColTemp2 As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordReasonCode)
                        If Not String.IsNullOrEmpty(ColTemp2) Then
                            If ColTemp2 = "1" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "2" Then
                                ItemTemp.SubItems.Add("認証局の秘密鍵が紛失・盗難などにより信頼性が失墜したため")
                            ElseIf ColTemp2 = "3" Then
                                ItemTemp.SubItems.Add("所有者・サーバーの内容（部署・名前など）に変更があったため")
                            ElseIf ColTemp2 = "4" Then
                                ItemTemp.SubItems.Add("内容の変更をともなわない証明書の交換")
                            ElseIf ColTemp2 = "5" Then
                                ItemTemp.SubItems.Add("所有者の退職・サービスの終了などにより証明書が不要となった")
                            Else
                                ItemTemp.SubItems.Add("その他")
                            End If
                        Else
                            ItemTemp.SubItems.Add("-")
                        End If
                        ItemTemp.SubItems.Add(ColTemp)
                        ItemTemp.ForeColor = Color.Silver
                    Else
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.SubItems.Add("-")
                        ItemTemp.ForeColor = SystemColors.ControlText
                    End If
                    Me.ListView1.Items.Add(ItemTemp)
                End If
            Next
            Erase ChildList
        End If
    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "RevocateCert10.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel2_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel2.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "RevocateCert11.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel3_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel3.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "RevocateCert38.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub

    Private Sub LinkLabel4_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel4.LinkClicked
        Dim BaseDirectory = System.Windows.Forms.Application.StartupPath
        Dim SouceFolder = "/source/k9pca/k9pca/90_Help/"
        Dim HelpFile = BaseDirectory & SouceFolder & "RevocateCert39.htm"
        System.Diagnostics.Process.Start(HelpFile)
    End Sub
End Class