﻿Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class RevocateCert03
    Public RGdata As RegistData
    Public K9piaExecDirectory As String
    Public K9piaExecName As String
    Public K9piaCertDirectoryBase As String
    Public SerialNumber As ArrayList
    Public Issuer As Long
    Public ReasonCode As Integer
    Public RevocateDate As Date
    Public CheckOk As Boolean
    Public RetCode As Integer
    Private BreakFlag As Boolean
    Private LOGdata As LogFile

    Private Sub RevocateCert03_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug 証明書の失効の実行画面クラスが作成されました。")
        Me.CheckOk = False                                             ' コンストラクタ：初期化します
        Me.RetCode = -1
        Me.LabelCreateEnd.ForeColor = SystemColors.Control             ' 完了メッセージを背景色と同じにして見えなくさせます
        Me.LabelRegistEnd.ForeColor = SystemColors.Control
        Me.LabelAllEnd.ForeColor = SystemColors.Control
        Me.BreakFlag = False
        Me.LOGdata = New LogFile()
    End Sub

    Private Sub RevocateCert03_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Debug.WriteLine("debug 証明書の失効の実行画面クラスが表示されました。")
        Me.BackgroundWorker1.RunWorkerAsync()                          ' 表示と同時にバックグラウンド処理を開始します
    End Sub

    Private Sub ButtonCancel_Click(sender As Object, e As EventArgs) Handles ButtonCancel.Click
        Debug.WriteLine("debug 証明書の失効の実行画面で〔キャンセル〕が押されました。")
        Me.CheckOk = False                                             ' キャンセル処理です
        Me.BreakFlag = True
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Debug.WriteLine("debug 証明書の失効のバックグラウンド処理を開始します。")
        Dim K9pia As k9piaCertRevocate = New k9piaCertRevocate         ' バックグラウンド処理です
        K9pia.K9piaExecDirectory = Me.K9piaExecDirectory               ' 発行局(k9pia)との接続を開始します
        K9pia.K9piaExecName = Me.K9piaExecName
        For i As Integer = 0 To Me.SerialNumber.Count - 1 Step 1
            Me.RetCode = -1
            K9pia.SerialNumber = Me.SerialNumber(i)
            If Me.ReasonCode < 6 Then
                K9pia.ReasonCode = Me.ReasonCode
            End If
            K9pia.RevocateDate = Me.RevocateDate
            If Not Me.BreakFlag Then
                Me.RetCode = K9pia.sendCommand()                       ' 発行局に証明書の失効を指示します
                Debug.WriteLine("debug 発行局もどり値 [" & Me.RetCode.ToString() & "]")
                Me.LOGdata.Logout("--------------------------------------------------------------------------------")
                If Me.RetCode = 0 Then
                    Me.LOGdata.Logout("証明書を失効しました。")
                    Me.LOGdata.Logout("証明書のシリアル番号 " & Me.SerialNumber(i).ToString())
                Else
                    Me.LOGdata.Logout("証明書の失効に失敗しました。")
                    Me.LOGdata.Logout("証明書のシリアル番号 " & Me.SerialNumber(i).ToString())
                End If
            Else
                Me.RetCode = -3
                Me.LOGdata.Logout("証明書の失効がキャンセルされました。")
                Me.LOGdata.Logout("証明書のシリアル番号 " & Me.SerialNumber(i).ToString())
                Exit For
            End If
            If (Me.RetCode = 0) Or (Me.RetCode = 43042) Then
                Me.RetCode = -2                                        ' 終了コードを変更して処理を続けます
                Me.LabelCreateEnd.ForeColor = SystemColors.ControlText ' 完了メッセージを黒にして見えるようにします
                RGdata.SetRevocate(Me.SerialNumber(i), Me.ReasonCode, Me.RevocateDate) ' 登録情報ファイルに書き込みます
                If Not Me.BreakFlag Then
                    RGdata.WriteStack()
                    Me.LabelRegistEnd.ForeColor = SystemColors.ControlText ' 完了メッセージを黒にして見えるようにします
                    Me.LabelAllEnd.ForeColor = SystemColors.ControlText
                    Me.CheckOk = True                                      ' 終了コードに正常終了を設定します
                    Me.RetCode = 0                                         ' 完了メッセージ確認のためにちょっと待ち
                    Me.LOGdata.Logout("証明書が失効したことを登録しました。")
                    Me.LOGdata.Logout("証明書のシリアル番号 " & Me.SerialNumber(i).ToString())
                Else
                    RGdata.CancelStack()
                    Me.RetCode = -3
                    Me.LOGdata.Logout("証明書の失効登録がキャンセルされました。。")
                    Me.LOGdata.Logout("証明書のシリアル番号 " & Me.SerialNumber(i).ToString())
                    Exit For
                End If
            Else
                Me.LabelRegistEnd.Text = "… 失敗しました"             ' 発行局でエラーの場合
                Me.LabelRegistEnd.ForeColor = SystemColors.ControlText
                Exit For
            End If                                                     ' 続けてバックグラウンド処理の終了イベントに移ります
        Next
        If Me.RetCode = 0 Then
            System.Threading.Thread.Sleep(CommonDefines.MessageDilayTime)
        End If
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Debug.WriteLine("debug バックグラウンド処理の終了値 [" & Me.RetCode.ToString() & "]")
        If Me.RetCode <> 0 Then                                        ' バックグラウンド処理の終了イベントです
            Dim msg As String = "証明書の失効が失敗しました。"         ' エラーがあれば、ここでメッセージを表示します
            msg &= "エラーコード：" & Me.RetCode.ToString()
            If Me.RetCode = CommonDefines.ErrorCodeK9piaKeys Then
                msg &= " 再実行によりエラーが解消する場合があります。"
            ElseIf Me.RetCode = CommonDefines.ErrorCodeK9piaMakefile Then
                msg &= " フォルダの書き込み権限を確認してください。"
            End If
            MessageBox.Show(msg, "失効の失敗", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.CheckOk = False
        End If
        Me.Close()                                                     ' 画面を閉じます
    End Sub
End Class