﻿' * 名前 : AuthorityListBlock.vb
' * 機能 : 認証局のリスト
' * 作成 : 2014/04/-- Ver1.0
' * 更新 : ----/--/-- Ver -.-
' * 備考 : 証明書発行時に選択できる親認証局のリストです。。

Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class AuthorityListBlock
    Public Property Length As Integer                                  ' リストの要素数を保持します
    Public Property SerialNumber As Long()                             ' 認証局のシリアル番号を保持します
    Public Property SignatureAlgorithm As String()                     ' 認証局の署名アルゴリズムを保持します
    Public Property NotBefore As Date()                                ' 認証局の有効期限開始日を保持します
    Public Property NotAfter As Date()                                 ' 認証局の有効期限終了日を保持します
    Public Property Country As String()                                ' 認証局の国を保持します
    Public Property StateOrProvince As String()                        ' 認証局の都道府県を保持します
    Public Property Locality As String()                               ' 認証局の市区町村を保持します
    Public Property Organization As String()                           ' 認証局の組織を保持します
    Public Property OrganizationUnit As String()                       ' 認証局の部署を保持します
    Public Property CommonName As String()                             ' 認証局の固有名称を保持します
    Public Property PathLen As Integer()                               ' 認証局のパスの長さを保持します
    Public Property ProviderName As String()                           ' 認証局の暗号プロバイダの名前を保持します
    Public Property Keysize As Integer()                               ' 認証局の秘密鍵の鍵長を保持します
    Public Property CertificatePolicies As String()                    ' 認証局の発行者ステートメントを保持します
    Public Property PolicyOID As String()                              ' 認証局のポリシー識別子を保持します
    Public Property CRLDistributionPoints As String()                  ' 認証局のCRL配布ポイントを保持します
    Public Property AuthorityInfoAccess As String()                    ' 認証局の機関情報アクセスを保持します

    Public Sub New()                                                   ' コンストラクタ
        Me.Length = 0
    End Sub

    Public Sub GetArray(ByVal RGdata As RegistData)
        Dim TempLength As Integer = 0
        Dim TempSerialNumber() As Long = {0}
        Dim TempSignatureAlgorithm() As String = {""}
        Dim TempNotBefore() As Date = {Date.Now()}
        Dim TempNotAfter() As Date = {Date.Now()}
        Dim TempCountry() As String = {""}
        Dim TempStateOrProvince() As String = {""}
        Dim TempLocality() As String = {""}
        Dim TempOrganization() As String = {""}
        Dim TempOrganizationUnit() As String = {""}
        Dim TempCommonName() As String = {""}
        Dim TempPathLen() As Integer = {0}
        Dim TempProviderName() As String = {""}
        Dim TempKeysize() As Integer = {0}
        Dim TempCertificatePolicies() As String = {""}
        Dim TempPolicyOID() As String = {""}
        Dim TempCRLDistributionPoints() As String = {""}
        Dim TempAuthorityInfoAccess() As String = {""}
        Dim TempArray() As Long = RGdata.GetAuthorityList()
        If TempArray IsNot Nothing Then
            For i As Integer = 0 To TempArray.Length - 1 Step 1
                Dim RevoCode As Integer = RGdata.GetLong(TempArray(i), CommonDefines.RecordReasonCode)
                Dim NotBefore As DateTime = DateTime.Parse(RGdata.GetString(TempArray(i), CommonDefines.RecordNotbefore))
                Dim NotAfter As DateTime = DateTime.Parse(RGdata.GetString(TempArray(i), CommonDefines.RecordNotafter))
                If RevoCode = 0 Then
                    If (NotBefore < DateTime.Now()) And (DateTime.Now() < NotAfter) Then
                        Dim OrganizationName As String = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganiz)
                        Array.Resize(TempSerialNumber, (TempLength + 1))
                        Array.Resize(TempSignatureAlgorithm, (TempLength + 1))
                        Array.Resize(TempNotBefore, (TempLength + 1))
                        Array.Resize(TempNotAfter, (TempLength + 1))
                        Array.Resize(TempCountry, (TempLength + 1))
                        Array.Resize(TempStateOrProvince, (TempLength + 1))
                        Array.Resize(TempLocality, (TempLength + 1))
                        Array.Resize(TempOrganization, (TempLength + 1))
                        Array.Resize(TempOrganizationUnit, (TempLength + 1))
                        Array.Resize(TempCommonName, (TempLength + 1))
                        Array.Resize(TempPathLen, (TempLength + 1))
                        Array.Resize(TempProviderName, (TempLength + 1))
                        Array.Resize(TempKeysize, (TempLength + 1))
                        Array.Resize(TempCertificatePolicies, (TempLength + 1))
                        Array.Resize(TempPolicyOID, (TempLength + 1))
                        Array.Resize(TempCRLDistributionPoints, (TempLength + 1))
                        Array.Resize(TempAuthorityInfoAccess, (TempLength + 1))
                        TempSerialNumber(TempLength) = TempArray(i)
                        TempSignatureAlgorithm(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordSignalgo)
                        TempNotBefore(TempLength) = NotBefore
                        TempNotAfter(TempLength) = NotAfter
                        TempCountry(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordContry)
                        TempStateOrProvince(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordStateprov)
                        TempLocality(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordLocality)
                        TempOrganization(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganiz)
                        TempOrganizationUnit(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganizUnit)
                        TempCommonName(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordComname)
                        TempPathLen(TempLength) = RGdata.GetLong(TempArray(i), CommonDefines.RecordBcpath)
                        TempProviderName(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCSPname)
                        TempKeysize(TempLength) = RGdata.GetLong(TempArray(i), CommonDefines.RecordKeysize)
                        TempCertificatePolicies(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCpUri)
                        TempPolicyOID(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCpOID)
                        TempCRLDistributionPoints(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCRLdpUrl)
                        TempAuthorityInfoAccess(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordAinfoCA)
                        TempLength += 1
                    Else
                        Debug.WriteLine("debug 有効期限 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                    End If
                Else
                    Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
                End If
            Next
        End If
        If TempLength > 0 Then
            Me.SerialNumber = TempSerialNumber.Clone
            Me.SignatureAlgorithm = TempSignatureAlgorithm.Clone
            Me.NotBefore = TempNotBefore.Clone
            Me.NotAfter = TempNotAfter.Clone
            Me.Country = TempCountry.Clone
            Me.StateOrProvince = TempStateOrProvince.Clone
            Me.Locality = TempLocality.Clone
            Me.Organization = TempOrganization.Clone
            Me.OrganizationUnit = TempOrganizationUnit.Clone
            Me.CommonName = TempCommonName.Clone
            Me.PathLen = TempPathLen.Clone
            Me.ProviderName = TempProviderName.Clone
            Me.Keysize = TempKeysize.Clone
            Me.CertificatePolicies = TempCertificatePolicies.Clone
            Me.PolicyOID = TempPolicyOID.Clone
            Me.CRLDistributionPoints = TempCRLDistributionPoints.Clone
            Me.AuthorityInfoAccess = TempAuthorityInfoAccess.Clone
            Me.Length = TempLength
        End If
        Erase TempArray
        Erase TempSerialNumber
        Erase TempSignatureAlgorithm
        Erase TempNotBefore
        Erase TempNotAfter
        Erase TempCountry
        Erase TempStateOrProvince
        Erase TempLocality
        Erase TempOrganization
        Erase TempOrganizationUnit
        Erase TempCommonName
        Erase TempPathLen
        Erase TempProviderName
        Erase TempKeysize
        Erase TempCertificatePolicies
        Erase TempPolicyOID
        Erase TempCRLDistributionPoints
        Erase TempAuthorityInfoAccess
    End Sub

    Public Sub GetArrayMiddle(ByVal RGdata As RegistData)
        Dim TempLength As Integer = 0
        Dim TempSerialNumber() As Long = {0}
        Dim TempSignatureAlgorithm() As String = {""}
        Dim TempNotBefore() As Date = {Date.Now()}
        Dim TempNotAfter() As Date = {Date.Now()}
        Dim TempCountry() As String = {""}
        Dim TempStateOrProvince() As String = {""}
        Dim TempLocality() As String = {""}
        Dim TempOrganization() As String = {""}
        Dim TempOrganizationUnit() As String = {""}
        Dim TempCommonName() As String = {""}
        Dim TempPathLen() As Integer = {0}
        Dim TempProviderName() As String = {""}
        Dim TempKeysize() As Integer = {0}
        Dim TempCertificatePolicies() As String = {""}
        Dim TempPolicyOID() As String = {""}
        Dim TempCRLDistributionPoints() As String = {""}
        Dim TempAuthorityInfoAccess() As String = {""}
        Dim TempArray() As Long = RGdata.GetAuthorityList()
        For i As Integer = 0 To TempArray.Length - 1 Step 1
            Dim RevoCode As Integer = RGdata.GetLong(TempArray(i), CommonDefines.RecordReasonCode)
            Dim NotBefore As DateTime = DateTime.Parse(RGdata.GetString(TempArray(i), CommonDefines.RecordNotbefore))
            Dim NotAfter As DateTime = DateTime.Parse(RGdata.GetString(TempArray(i), CommonDefines.RecordNotafter))
            Dim BcPath As Integer = RGdata.GetLong(TempArray(i), CommonDefines.RecordBcpath)
            If RevoCode = 0 Then
                If (NotBefore < DateTime.Now()) And (DateTime.Now() < NotAfter) Then
                    If (BcPath < 0) Or (BcPath > 0) Then
                        Dim OrganizationName As String = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganiz)
                        Array.Resize(TempSerialNumber, (TempLength + 1))
                        Array.Resize(TempSignatureAlgorithm, (TempLength + 1))
                        Array.Resize(TempNotBefore, (TempLength + 1))
                        Array.Resize(TempNotAfter, (TempLength + 1))
                        Array.Resize(TempCountry, (TempLength + 1))
                        Array.Resize(TempStateOrProvince, (TempLength + 1))
                        Array.Resize(TempLocality, (TempLength + 1))
                        Array.Resize(TempOrganization, (TempLength + 1))
                        Array.Resize(TempOrganizationUnit, (TempLength + 1))
                        Array.Resize(TempCommonName, (TempLength + 1))
                        Array.Resize(TempPathLen, (TempLength + 1))
                        Array.Resize(TempProviderName, (TempLength + 1))
                        Array.Resize(TempKeysize, (TempLength + 1))
                        Array.Resize(TempCertificatePolicies, (TempLength + 1))
                        Array.Resize(TempPolicyOID, (TempLength + 1))
                        Array.Resize(TempCRLDistributionPoints, (TempLength + 1))
                        Array.Resize(TempAuthorityInfoAccess, (TempLength + 1))
                        TempSerialNumber(TempLength) = TempArray(i)
                        TempSignatureAlgorithm(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordSignalgo)
                        TempNotBefore(TempLength) = NotBefore
                        TempNotAfter(TempLength) = NotAfter
                        TempCountry(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordContry)
                        TempStateOrProvince(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordStateprov)
                        TempLocality(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordLocality)
                        TempOrganization(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganiz)
                        TempOrganizationUnit(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordOrganizUnit)
                        TempCommonName(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordComname)
                        TempPathLen(TempLength) = RGdata.GetLong(TempArray(i), CommonDefines.RecordBcpath)
                        TempProviderName(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCSPname)
                        TempKeysize(TempLength) = RGdata.GetLong(TempArray(i), CommonDefines.RecordKeysize)
                        TempCertificatePolicies(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCpUri)
                        TempPolicyOID(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCpOID)
                        TempCRLDistributionPoints(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordCRLdpUrl)
                        TempAuthorityInfoAccess(TempLength) = RGdata.GetString(TempArray(i), CommonDefines.RecordAinfoCA)
                        TempLength += 1
                    End If
                Else
                    Debug.WriteLine("debug 有効期限 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                End If
            Else
                Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
            End If
        Next
        If TempLength > 0 Then
            Me.SerialNumber = TempSerialNumber.Clone
            Me.SignatureAlgorithm = TempSignatureAlgorithm.Clone
            Me.NotBefore = TempNotBefore.Clone
            Me.NotAfter = TempNotAfter.Clone
            Me.Country = TempCountry.Clone
            Me.StateOrProvince = TempStateOrProvince.Clone
            Me.Locality = TempLocality.Clone
            Me.Organization = TempOrganization.Clone
            Me.OrganizationUnit = TempOrganizationUnit.Clone
            Me.CommonName = TempCommonName.Clone
            Me.PathLen = TempPathLen.Clone
            Me.ProviderName = TempProviderName.Clone
            Me.Keysize = TempKeysize.Clone
            Me.CertificatePolicies = TempCertificatePolicies.Clone
            Me.PolicyOID = TempPolicyOID.Clone
            Me.CRLDistributionPoints = TempCRLDistributionPoints.Clone
            Me.AuthorityInfoAccess = TempAuthorityInfoAccess.Clone
            Me.Length = TempLength
        End If
        Erase TempArray
        Erase TempSerialNumber
        Erase TempSignatureAlgorithm
        Erase TempNotBefore
        Erase TempNotAfter
        Erase TempCountry
        Erase TempStateOrProvince
        Erase TempLocality
        Erase TempOrganization
        Erase TempOrganizationUnit
        Erase TempCommonName
        Erase TempPathLen
        Erase TempProviderName
        Erase TempKeysize
        Erase TempCertificatePolicies
        Erase TempPolicyOID
        Erase TempCRLDistributionPoints
        Erase TempAuthorityInfoAccess
    End Sub
End Class
