﻿' * 名前 : Form1.vb
' * 機能 : メイン・プログラム
' * 作成 : 2014/04/-- Ver1.0
' * 更新 : 2014/08/03 Ver1.1
' * 備考 : 
' *

Imports Microsoft.VisualBasic.ControlChars
Imports System.IO
Imports System.Text
Imports System.Diagnostics

Public Class Form1
    Public LogDirectory As String
    Public LogName As String
    Private BIdata As BaseInfoData
    Private RGdata As RegistData
    Private LOGdata As LogFile
    Private TreeMax As Integer
    Private CertType As Integer

    ' ****** 実行開始の初期処理です ******
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Debug.WriteLine("debug プログラムを開始します。")
        Me.TreeMax = 0
        Me.CertType = -1
        BIdata = New BaseInfoData                                      ' 既存の基本情報ファイルを確認します
        If BIdata.DataReady = CommonDefines.StatusFileReady Then       ' 基本情報ファイルが存在する場合
            Debug.WriteLine("debug 基本情報ファイルが準備できました。")
            Me.LogDirectory = BIdata.BaseDirectory + BIdata.LogDirectory
            Me.LogName = BIdata.LogName
            Me.LOGdata = New LogFile()
            '                                                            登録情報ファイルを準備します
            RGdata = New RegistData(BIdata.BaseDirectory & BIdata.RegistDirectory, BIdata.RegistName)
            Debug.WriteLine("debug 登録情報ファイルが準備できました。")

            Me.TreeViewDisplay()                                       ' ツリーを表示します
            Dim NumList() As Long = RGdata.GetAuthorityList()
            If NumList IsNot Nothing Then
                Me.CertTableDisplay(NumList(0))                        ' 右側詳細を表示します
                Debug.WriteLine("debug ツリーを表示しました。")
            Else
                Me.CertTableClear()                                    ' 右側詳細を消去します
                Debug.WriteLine("debug ツリーに表示するものがありません。")
            End If

            Me.ルート認証局の構築BToolStripMenuItem.Enabled = True     ' メニューを有効化します
            Me.認証局のインポートIToolStripMenuItem.Enabled = True
            If Me.TreeMax > 0 Then
                Me.中間認証局の構築NToolStripMenuItem.Enabled = True
                Me.個人証明書の作成UToolStripMenuItem.Enabled = True
                Me.サーバー証明書の作成SToolStripMenuItem.Enabled = True
                Me.証明書の失効RToolStripMenuItem.Enabled = True
                Me.失効リストの作成LToolStripMenuItem.Enabled = True
            End If
            Me.ログ表示LToolStripMenuItem.Enabled = True
            Debug.WriteLine("debug メニューを有効にしました。")
            LOGdata.Logout("認証局を開始します。 プログラム名 [k9pca Ver2.0]")
            LOGdata.Logout("マシン名 [" + Environment.MachineName + "]")
        Else                                                           ' 基本情報ファイルが存在しない場合
            Debug.WriteLine("debug 基本情報ファイルが準備できていません。")
            'Me.CertTableClear()
            Dim FormFirstCond As New FirstCond                         ' 新規と見なして初期画面を表示します
            FormFirstCond.Location = Me.Location
            FormFirstCond.ShowDialog()                                 ' -> 使用条件の確認画面
            If FormFirstCond.Agreement Then
                Dim FormFirstSetup As New FirstSetup
                FormFirstSetup.Location = Me.Location
                FormFirstSetup.ShowDialog()                            ' -> 基本情報の設定画面
                If FormFirstSetup.CrlCycle IsNot Nothing Then
                    Debug.WriteLine("debug 基本情報の設定：ルートのシリアル番号 [" & FormFirstSetup.SerialNumberRoot.ToString() & "]")
                    Debug.WriteLine("debug 基本情報の設定：中間のシリアル番号 　[" & FormFirstSetup.SerialNumberMiddle.ToString() & "]")
                    Debug.WriteLine("debug 基本情報の設定：個人のシリアル番号　 [" & FormFirstSetup.SerialNumberUser.ToString() & "]")
                    Debug.WriteLine("debug 基本情報の設定：サーバのシリアル番号 [" & FormFirstSetup.SerialNumberServer.ToString() & "]")
                    Debug.WriteLine("debug 基本情報の設定：ＣＲＬのシリアル番号 [" & FormFirstSetup.SerialNumberCrl.ToString() & "]")
                    Debug.WriteLine("debug 基本情報の設定：ＣＲＬのサイクル　　 [" & FormFirstSetup.CrlCycle & "]")
                    BIdata.SerialNumberRoot = FormFirstSetup.SerialNumberRoot  ' 基本情報ファイルを作成します
                    BIdata.SerialNumberMiddle = FormFirstSetup.SerialNumberMiddle
                    BIdata.SerialNumberUser = FormFirstSetup.SerialNumberUser
                    BIdata.SerialNumberServer = FormFirstSetup.SerialNumberServer
                    BIdata.SerialNumberCrl = FormFirstSetup.SerialNumberCrl
                    BIdata.CrlCycle = FormFirstSetup.CrlCycle
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを作成しました。")
                    Me.LogDirectory = BIdata.BaseDirectory + BIdata.LogDirectory
                    Me.LogName = BIdata.LogName
                    Me.LOGdata = New LogFile()
                    LOGdata.Logout("基本情報ファイルを作成しました。")
                    '                                                    登録情報ファイルを作成します
                    RGdata = New RegistData(BIdata.BaseDirectory & BIdata.RegistDirectory, BIdata.RegistName)
                    Me.CertTableClear()
                    Debug.WriteLine("debug 登録情報ファイルを作成しました。")
                    LOGdata.Logout("登録情報ファイルを作成しました。")

                    Dim K9pia As k9piaInitialSetup = New k9piaInitialSetup ' 発行局を初期化します
                    K9pia.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
                    K9pia.K9piaExecName = BIdata.K9piaName
                    'K9pia.K9piaManageDirectory = K9pia.K9piaExecDirectory & "files/"
                    K9pia.K9piaManageDirectory = "/files/"
                    K9pia.K9piaManageName = "Serial.db"
                    'K9pia.K9piaLogDirectory = K9pia.K9piaExecDirectory & "log/"
                    'K9pia.K9piaLogName = "k9pia"
                    K9pia.K9piaLogDirectory = "/log/"
                    K9pia.K9piaLogName = Me.LogName
                    Dim PiaCode As Integer = K9pia.sendCommand()
                    Debug.WriteLine("debug 発行局を初期化しました。")
                    LOGdata.Logout("発行局を初期化しました。")

                    If PiaCode = 0 Then                                ' 初回開始時のメニューを有効化します
                        Me.ルート認証局の構築BToolStripMenuItem.Enabled = True
                        Me.認証局のインポートIToolStripMenuItem.Enabled = True
                        Me.ログ表示LToolStripMenuItem.Enabled = True
                        Debug.WriteLine("debug 初期メニューを有効にしました。")
                        Me.CertTableClear()                            ' 右側詳細の消去
                        LOGdata.Logout("認証局を開始します。 プログラム名 [k9pca Ver2.0]")
                        LOGdata.Logout("マシン名 [" + Environment.MachineName + "]")
                    Else
                        Debug.WriteLine("debug 認証局の初期化が失敗しました。")
                        LOGdata.Logout("認証局の初期化が失敗しました。")
                    End If
                Else
                    Debug.WriteLine("debug 基本情報の設定で〔キャンセル〕が押されました。")
                    ' Me.Close()                                       ' プログラムは終了させません
                End If
            Else
                Debug.WriteLine("debug 使用条件の確認で〔キャンセル〕または「同意しない」が選択されました。")
                ' Me.Close()                                           ' プログラムは終了させません
            End If
        End If
    End Sub

    ' ****** ツリービューを表示します ******
    Private Sub TreeViewDisplay()
        Dim NumList() As Long = Me.RGdata.GetAuthorityList()           ' 認証局のシリアル番号をリストアップします
        If NumList IsNot Nothing Then
            Me.TreeView1.Nodes.Clear()
            Me.TreeMax = 0
            Dim NumRoot As Long = NumList(0)
            For i As Integer = 0 To NumList.Length - 1 Step 1          ' 認証局を順番にツリービューに表示していきます
                NumRoot = NumList(i)
                Debug.WriteLine("debug 認証局シリアル番号 [" & NumRoot.ToString() & "]")
                Dim OrganizationName As String = Me.RGdata.GetString(NumRoot, CommonDefines.RecordOrganiz)
                Dim NodeTitle As String = String.Format("{0} {1}", NumRoot.ToString(), OrganizationName)
                Me.TreeView1.Nodes.Add(New TreeNode(NodeTitle))
                Dim RevoCode As Integer = Me.RGdata.GetLong(NumRoot, CommonDefines.RecordReasonCode)
                Dim NotBefore As DateTime = DateTime.Parse(Me.RGdata.GetString(NumRoot, CommonDefines.RecordNotbefore))
                Dim NotAfter As DateTime = DateTime.Parse(Me.RGdata.GetString(NumRoot, CommonDefines.RecordNotafter))
                Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
                If RevoCode = 0 Then
                    Debug.WriteLine("debug 有効期間 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                    If (NotBefore <= DateTime.Now) And (DateTime.Now <= NotAfter) Then
                        Me.TreeView1.Nodes(Me.TreeMax).ForeColor = Color.Black
                        Me.TreeView1.Nodes(Me.TreeMax).ImageIndex = 1
                        Me.TreeView1.Nodes(Me.TreeMax).SelectedImageIndex = 1
                    Else
                        Me.TreeView1.Nodes(Me.TreeMax).ForeColor = Color.Silver
                        Me.TreeView1.Nodes(Me.TreeMax).ImageIndex = 2
                        Me.TreeView1.Nodes(Me.TreeMax).SelectedImageIndex = 2
                    End If
                Else
                    Me.TreeView1.Nodes(Me.TreeMax).ForeColor = Color.Silver
                    Me.TreeView1.Nodes(Me.TreeMax).ImageIndex = 2
                    Me.TreeView1.Nodes(Me.TreeMax).SelectedImageIndex = 2
                End If
                Dim ChildNum As Long                                ' ツリービューに子証明書を登録していきます
                Dim ChildNode As Integer = 0
                Dim ChildMiddleList() As Long = Me.RGdata.GetMiddleList(NumRoot) ' 中間認証局の登録
                If ChildMiddleList IsNot Nothing Then
                    For j As Integer = 0 To ChildMiddleList.Length - 1 Step 1
                        ChildNum = ChildMiddleList(j)
                        Debug.WriteLine("debug 認証局シリアル番号 [" & NumRoot.ToString() & "]  子証明書 [" & ChildNum.ToString() & "]")
                        If ChildNum > 0 Then
                            Dim CommonName As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordOrganiz)
                            'Dim CommonName As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname)
                            Dim ChildTitle As String = String.Format("{0} {1}", ChildNum.ToString(), CommonName)
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes.Add(New TreeNode(ChildTitle))
                            RevoCode = Me.RGdata.GetLong(ChildNum, CommonDefines.RecordReasonCode)
                            NotBefore = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            NotAfter = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
                            If RevoCode = 0 Then
                                Debug.WriteLine("debug 有効期間 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                                If (NotBefore <= DateTime.Now) And (DateTime.Now <= NotAfter) Then
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Gray
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 3
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 3
                                Else
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 4
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 4
                                End If
                            Else
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 4
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 4
                            End If
                            ChildNode += 1
                        End If
                    Next
                    Erase ChildMiddleList
                End If
                Dim ChildUserList() As Long = Me.RGdata.GetUserList(NumRoot)             ' 個人証明書の登録
                If ChildUserList IsNot Nothing Then
                    For j As Integer = 0 To ChildUserList.Length - 1 Step 1
                        ChildNum = ChildUserList(j)
                        Debug.WriteLine("debug 認証局シリアル番号 [" & NumRoot.ToString() & "]  子証明書 [" & ChildNum.ToString() & "]")
                        If ChildNum > 0 Then
                            Dim CommonName As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname)
                            Dim ChildTitle As String = String.Format("{0} {1}", ChildNum.ToString(), CommonName)
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes.Add(New TreeNode(ChildTitle))
                            RevoCode = Me.RGdata.GetLong(ChildNum, CommonDefines.RecordReasonCode)
                            NotBefore = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            NotAfter = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
                            If RevoCode = 0 Then
                                Debug.WriteLine("debug 有効期間 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                                If (NotBefore <= DateTime.Now) And (DateTime.Now <= NotAfter) Then
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Black
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 5
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 5
                                Else
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 6
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 6
                                End If
                            Else
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 6
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 6
                            End If
                            ChildNode += 1
                        End If
                    Next
                    Erase ChildUserList
                End If
                Dim ChildServerList() As Long = Me.RGdata.GetServerList(NumRoot)           ' サーバー証明書の登録
                If ChildServerList IsNot Nothing Then
                    For j As Integer = 0 To ChildServerList.Length - 1 Step 1
                        ChildNum = ChildServerList(j)
                        Debug.WriteLine("debug 認証局シリアル番号 [" & NumRoot.ToString() & "]  子証明書 [" & ChildNum.ToString() & "]")
                        If ChildNum > 0 Then
                            Dim CommonName As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordComname)
                            Dim ChildTitle As String = String.Format("{0} {1}", ChildNum.ToString(), CommonName)
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes.Add(New TreeNode(ChildTitle))
                            RevoCode = Me.RGdata.GetLong(ChildNum, CommonDefines.RecordReasonCode)
                            NotBefore = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotbefore))
                            NotAfter = DateTime.Parse(Me.RGdata.GetString(ChildNum, CommonDefines.RecordNotafter))
                            Debug.WriteLine("debug 失効理由 [" & RevoCode.ToString() & "]")
                            If RevoCode = 0 Then
                                Debug.WriteLine("debug 有効期間 [" & NotBefore.ToString() & "] [" & NotAfter.ToString() & "]")
                                If (NotBefore <= DateTime.Now) And (DateTime.Now <= NotAfter) Then
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Black
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 7
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 7
                                Else
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 8
                                    Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 8
                                End If
                            Else
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Silver
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 8
                                Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 8
                            End If
                            ChildNode += 1
                        End If
                    Next
                    Erase ChildServerList
                End If
                Dim ChildCrlList() As Long = Me.RGdata.GetCRLlist(NumRoot)              ' 失効リストの登録
                If ChildCrlList IsNot Nothing Then
                    For j As Integer = 0 To ChildCrlList.Length - 1 Step 1
                        ChildNum = ChildCrlList(j)
                        Debug.WriteLine("debug 認証局シリアル番号 [" & NumRoot.ToString() & "]  子証明書 [" & ChildNum.ToString() & "]")
                        If ChildNum > 0 Then
                            Dim ThisUpdate As String = Me.RGdata.GetString(ChildNum, CommonDefines.RecordThisUpdate)
                            Dim ChildTitle As String = String.Format("{0} CRL[{1}]", ChildNum.ToString(), ThisUpdate)
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes.Add(New TreeNode(ChildTitle))
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ForeColor = Color.Black
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).ImageIndex = 9
                            Me.TreeView1.Nodes(Me.TreeMax).Nodes(ChildNode).SelectedImageIndex = 9
                            ChildNode += 1
                        End If
                    Next
                    Erase ChildCrlList
                End If
                Me.TreeMax += 1
            Next
            Me.TreeView1.ShowPlusMinus = True
            Me.TreeView1.ShowLines = True
        Else
            Debug.WriteLine("debug シリアル番号がありません。。")
            Me.TreeView1.Nodes.Clear()
            Dim NodeTitle As String = "認証局が構築されていません"
            Me.TreeView1.Nodes.Add(New TreeNode(NodeTitle))
            Me.TreeView1.Nodes(0).ForeColor = Color.Red
        End If
    End Sub

    ' ****** ツリービューに認証局を追加します ******
    Private Sub TreeViewAddAuthority(ByVal SerialNumber As Long)
        Debug.WriteLine("debug 認証局シリアル番号 [" & SerialNumber.ToString() & "]")
        Dim OrganizationName As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordOrganiz)
        Dim NodeTitle As String = String.Format("{0} {1}", SerialNumber.ToString(), OrganizationName)
        If Me.TreeMax = 0 Then
            Me.TreeView1.Nodes(0).Text = NodeTitle
            Me.TreeView1.ShowPlusMinus = True
            Me.TreeView1.ShowLines = True
        Else
            Me.TreeView1.Nodes.Add(New TreeNode(NodeTitle))
        End If
        Me.TreeView1.Nodes(Me.TreeMax).ForeColor = Color.Black
        Me.TreeView1.Nodes(Me.TreeMax).ImageIndex = 1
        Me.TreeView1.Nodes(Me.TreeMax).SelectedImageIndex = 1
        Me.TreeMax += 1
    End Sub

    ' ****** ツリービューに中間認証局（子）を追加します ******
    Private Sub TreeViewAddMiddle(ByVal SerialNumber As Long, ByVal Issuer As Long)
        Debug.WriteLine("debug 認証局（親）シリアル番号 [" & Issuer.ToString() & "]")
        Debug.WriteLine("debug 認証局（子）シリアル番号 [" & SerialNumber.ToString() & "]")
        Dim Otemp As String = Me.RGdata.GetString(Issuer, CommonDefines.RecordOrganiz)
        Dim OrganizationName As String = String.Format("{0} {1}", Issuer.ToString(), Otemp)
        Dim Oya As Integer = -1
        For i As Integer = 0 To Me.TreeView1.GetNodeCount(False) - 1 Step 1
            If Me.TreeView1.Nodes(i).Text = OrganizationName Then
                Oya = i
            End If
        Next
        If Oya >= 0 Then
            Dim Kodomo As Integer = Me.TreeView1.Nodes(Oya).GetNodeCount(False)
            Dim ChildName As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordOrganiz)
            Dim NodeTitle As String = String.Format("{0} {1}", SerialNumber.ToString(), ChildName)
            Me.TreeView1.Nodes(Oya).Nodes.Add(New TreeNode(NodeTitle))
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ForeColor = Color.Black
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ImageIndex = 3
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).SelectedImageIndex = 3
            Me.TreeView1.Nodes(Oya).Expand()
        End If
    End Sub

    ' ****** ツリービューに個人証明書を追加します ******
    Private Sub TreeViewAddUser(ByVal SerialNumber As Long, ByVal Issuer As Long)
        Debug.WriteLine("debug 認証局シリアル番号 [" & Issuer.ToString() & "]")
        Debug.WriteLine("debug 証明書シリアル番号 [" & SerialNumber.ToString() & "]")
        Dim Otemp As String = Me.RGdata.GetString(Issuer, CommonDefines.RecordOrganiz)
        Dim OrganizationName As String = String.Format("{0} {1}", Issuer.ToString(), Otemp)
        Dim Oya As Integer = -1
        For i As Integer = 0 To Me.TreeView1.GetNodeCount(False) - 1 Step 1
            If Me.TreeView1.Nodes(i).Text = OrganizationName Then
                Oya = i
            End If
        Next
        If Oya >= 0 Then
            Dim Kodomo As Integer = Me.TreeView1.Nodes(Oya).GetNodeCount(False)
            Dim CommonName As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordComname)
            Dim NodeTitle As String = String.Format("{0} {1}", SerialNumber.ToString(), CommonName)
            Me.TreeView1.Nodes(Oya).Nodes.Add(New TreeNode(NodeTitle))
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ForeColor = Color.Black
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ImageIndex = 5
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).SelectedImageIndex = 5
            Me.TreeView1.Nodes(Oya).Expand()
        End If
    End Sub

    ' ****** ツリービューにサーバー証明書を追加します ******
    Private Sub TreeViewAddServer(ByVal SerialNumber As Long, ByVal Issuer As Long)
        Debug.WriteLine("debug 認証局シリアル番号 [" & Issuer.ToString() & "]")
        Debug.WriteLine("debug 証明書シリアル番号 [" & SerialNumber.ToString() & "]")
        Dim Otemp As String = Me.RGdata.GetString(Issuer, CommonDefines.RecordOrganiz)
        Dim OrganizationName As String = String.Format("{0} {1}", Issuer.ToString(), Otemp)
        Dim Oya As Integer = -1
        For i As Integer = 0 To Me.TreeView1.GetNodeCount(False) - 1 Step 1
            If Me.TreeView1.Nodes(i).Text = OrganizationName Then
                Oya = i
            End If
        Next
        If Oya >= 0 Then
            Dim Kodomo As Integer = Me.TreeView1.Nodes(Oya).GetNodeCount(False)
            Dim CommonName As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordComname)
            Dim NodeTitle As String = String.Format("{0} {1}", SerialNumber.ToString(), CommonName)
            Me.TreeView1.Nodes(Oya).Nodes.Add(New TreeNode(NodeTitle))
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ForeColor = Color.Black
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ImageIndex = 7
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).SelectedImageIndex = 7
            Me.TreeView1.Nodes(Oya).Expand()
        End If
    End Sub

    ' ****** ツリービューに失効リストを追加します ******
    Private Sub TreeViewAddCrl(ByVal SerialNumber As Long, ByVal Issuer As Long)
        Debug.WriteLine("debug 認証局シリアル番号 [" & Issuer.ToString() & "]")
        Debug.WriteLine("debug 証明書シリアル番号 [" & SerialNumber.ToString() & "]")
        Dim Otemp As String = Me.RGdata.GetString(Issuer, CommonDefines.RecordOrganiz)
        Dim OrganizationName As String = String.Format("{0} {1}", Issuer.ToString(), Otemp)
        Dim Oya As Integer = -1
        For i As Integer = 0 To Me.TreeView1.GetNodeCount(False) - 1 Step 1
            If Me.TreeView1.Nodes(i).Text = OrganizationName Then
                Oya = i
            End If
        Next
        If Oya >= 0 Then
            Dim Kodomo As Integer = Me.TreeView1.Nodes(Oya).GetNodeCount(False)
            Dim ThisUpdate As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordThisUpdate)
            Dim NodeTitle As String = String.Format("{0} CRL[{1}]", SerialNumber.ToString(), ThisUpdate)
            Me.TreeView1.Nodes(Oya).Nodes.Add(New TreeNode(NodeTitle))
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ForeColor = Color.Black
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).ImageIndex = 9
            Me.TreeView1.Nodes(Oya).Nodes(Kodomo).SelectedImageIndex = 9
            Me.TreeView1.Nodes(Oya).Expand()
        End If
    End Sub

    ' ****** 証明書の内容を消去します ******
    Private Sub CertTableClear()
        Debug.WriteLine("debug 証明書の内容を消去します。")
        Me.TableLayoutPanel1.Visible = False
        Me.TextBoxVersion.Text = ""
        Me.TextBoxSerialNumber.Text = ""
        Me.TextBoxSignatureAlgorithm.Text = ""
        Me.TextBoxNotBefore.Text = ""
        Me.TextBoxNotAfter.Text = ""
        Me.TextBoxCountryName.Text = ""
        Me.TextBoxStateOrProvinceName.Text = ""
        Me.TextBoxLocalityName.Text = ""
        Me.TextBoxOrganizationName.Text = ""
        Me.TextBoxOrganizationUnitName.Text = ""
        Me.TextBoxCommonName.Text = ""
        Me.TextBoxEmail.Text = ""
        Me.TextBoxJICountryName.Text = ""
        Me.TextBoxJIStateOrProvinceName.Text = ""
        Me.TextBoxJILocalityName.Text = ""
        Me.TextBoxJINumber.Text = ""
        Me.TextBoxStreetAddress.Text = ""
        Me.TextBoxPostalCode.Text = ""
        Me.TextBoxBasicConstraints.Text = ""
        Me.TextBoxCertificatePolicies.Text = ""
        Me.TextBoxPolicyOID.Text = ""
        Me.TextBoxCRLDistributionPoints.Text = ""
        Me.TextBoxAuthorityInfoAccess.Text = ""
        Me.TextBoxCryptographicProviderNames.Text = ""
        Me.TextBoxKeySize.Text = ""
        Me.TextBoxRevocateDate.Text = ""
        Me.TextBoxReasonCode.Text = ""
    End Sub

    ' ****** 証明書の内容を表示します ******
    Private Sub CertTableDisplay(ByVal SerialNumber As Long)
        Debug.WriteLine("debug 証明書シリアル番号 [" & SerialNumber.ToString() & "]")
        Me.TextBoxVersion.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordVersion) ' バージョン
        Me.TextBoxSerialNumber.Text = SerialNumber.ToString()          ' シリアル番号
        Me.TextBoxSignatureAlgorithm.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordSignalgo) ' 署名アルゴリズム
        Me.LabelNotBefore.Text = "有効期間の開始" ' 有効期間
        Me.LabelNotAfter.Text = "有効期間の終了"
        Dim NotBefore As DateTime = DateTime.Parse(Me.RGdata.GetString(SerialNumber, CommonDefines.RecordNotbefore))
        Dim NotAfter As DateTime = DateTime.Parse(Me.RGdata.GetString(SerialNumber, CommonDefines.RecordNotafter))
        Me.TextBoxNotBefore.Text = NotBefore.ToString("yyyy年 MM月 dd日")
        Me.TextBoxNotAfter.Text = NotAfter.ToString("yyyy年 MM月 dd日")
        Me.TextBoxCountryName.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordContry) ' 所有者
        Dim s As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordStateprov)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxStateOrProvinceName.Text = "-"
        Else
            Me.TextBoxStateOrProvinceName.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordLocality)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxLocalityName.Text = "-"
        Else
            Me.TextBoxLocalityName.Text = s
        End If
        Me.TextBoxOrganizationName.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordOrganiz)
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordOrganizUnit)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxOrganizationUnitName.Text = "-"
        Else
            Me.TextBoxOrganizationUnitName.Text = s
        End If
        Me.TextBoxCommonName.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordComname)
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordEmail)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxEmail.Text = "-"
        Else
            Me.TextBoxEmail.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordJIContry)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxJICountryName.Text = "-"
        Else
            Me.TextBoxJICountryName.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordJIStateprov)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxJIStateOrProvinceName.Text = "-"
        Else
            Me.TextBoxJIStateOrProvinceName.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordJILocality)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxJILocalityName.Text = "-"
        Else
            Me.TextBoxJILocalityName.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordJINumber)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxJINumber.Text = "-"
        Else
            Me.TextBoxJINumber.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordJINumber)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxJINumber.Text = "-"
        Else
            Me.TextBoxJINumber.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordStreet)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxStreetAddress.Text = "-"
        Else
            Me.TextBoxStreetAddress.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordPostal)
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxPostalCode.Text = "-"
        Else
            Me.TextBoxPostalCode.Text = s
        End If
        Dim CertType As String = RGdata.GetCertType(SerialNumber)
        Dim x As Long = Me.RGdata.GetLong(SerialNumber, CommonDefines.RecordBccae) ' 基本制約
        If x <> 0 Then
            If CertType = CommonDefines.BlockRoot Then
                Me.TextBoxBasicConstraints.Text = "ルート認証局 / 下位認証局無制限"
            ElseIf CertType = CommonDefines.BlockMiddle Then
                Me.TextBoxBasicConstraints.Text = "中間認証局"
                Dim y As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordBcpath)
                If Not String.IsNullOrEmpty(y) Then
                    Me.TextBoxBasicConstraints.Text += " / 下位認証局 " & y & "世代まで"
                End If
            Else
                Me.TextBoxBasicConstraints.Text = "認証局"
                Dim y As String = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordBcpath)
                If Not String.IsNullOrEmpty(y) Then
                    Me.TextBoxBasicConstraints.Text += " / 下位認証局 " & y & "世代まで"
                End If
            End If
            Me.LabelCommonName.Text = "　一般名称／略称 (CN)"
        Else
            Me.TextBoxBasicConstraints.Text = "エンドエンティティ証明書"
            If CertType = CommonDefines.BlockUser Then
                Me.LabelCommonName.Text = "　氏名 (CN)"
            ElseIf CertType = CommonDefines.BlockServer Then
                Me.LabelCommonName.Text = "　ドメイン (CN)"
            Else
                Me.LabelCommonName.Text = "　固有名称 (CN)"
            End If
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordCpUri) ' 証明書ポリシー／ポリシーOID
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxCertificatePolicies.Text = "-"
            Me.TextBoxPolicyOID.Text = "-"
        Else
            Me.TextBoxCertificatePolicies.Text = s
            s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordCpOID)
            If String.IsNullOrEmpty(s) Then
                Me.TextBoxPolicyOID.Text = "-"
            Else
                Me.TextBoxPolicyOID.Text = s
            End If
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordCRLdpUrl) ' 失効リスト配布場所
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxCRLDistributionPoints.Text = "-"
        Else
            Me.TextBoxCRLDistributionPoints.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordAinfoCA) ' 認証局情報
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxAuthorityInfoAccess.Text = "-"
        Else
            Me.TextBoxAuthorityInfoAccess.Text = s
        End If
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordCSPname) ' 暗号プロバイダ
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxCryptographicProviderNames.Text = "-"
        Else
            Me.TextBoxCryptographicProviderNames.Text = s
        End If
        x = Me.RGdata.GetLong(SerialNumber, CommonDefines.RecordKeysize) ' 秘密鍵 鍵長
        Me.TextBoxKeySize.Text = x.ToString()
        s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordRevocate) ' 失効日付
        If String.IsNullOrEmpty(s) Then
            Me.TextBoxRevocateDate.Text = "-"
            Me.TextBoxReasonCode.Text = "-"
        Else
            Me.TextBoxRevocateDate.Text = s
            s = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordReasonCode)
            If Not String.IsNullOrEmpty(s) Then
                If s = "1" Then
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg1
                ElseIf s = "2" Then
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg2
                ElseIf s = "3" Then
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg3
                ElseIf s = "4" Then
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg4
                ElseIf s = "5" Then
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg5
                Else
                    Me.TextBoxReasonCode.Text = CommonDefines.ReasonMsg6
                End If
            Else
                Me.TextBoxReasonCode.Text = "-"
            End If
        End If
        ' Me.TextBoxVersion.Visible = True
        ' Me.TextBoxSerialNumber.Visible = True
        ' Me.TextBoxSignatureAlgorithm.Visible = True
        ' Me.TextBoxNotBefore.Visible = True
        ' Me.TextBoxNotAfter.Visible = True
        Me.TextBoxCountryName.Visible = True
        Me.TextBoxStateOrProvinceName.Visible = True
        Me.TextBoxLocalityName.Visible = True
        Me.TextBoxOrganizationName.Visible = True
        Me.TextBoxOrganizationUnitName.Visible = True
        Me.TextBoxCommonName.Visible = True
        Me.TextBoxEmail.Visible = True
        Me.TextBoxJICountryName.Visible = True
        Me.TextBoxJIStateOrProvinceName.Visible = True
        Me.TextBoxJILocalityName.Visible = True
        Me.TextBoxJINumber.Visible = True
        Me.TextBoxStreetAddress.Visible = True
        Me.TextBoxPostalCode.Visible = True
        Me.TextBoxBasicConstraints.Visible = True
        Me.TextBoxCertificatePolicies.Visible = True
        Me.TextBoxPolicyOID.Visible = True
        Me.TextBoxCRLDistributionPoints.Visible = True
        Me.TextBoxAuthorityInfoAccess.Visible = True
        Me.TextBoxCryptographicProviderNames.Visible = True
        Me.TextBoxKeySize.Visible = True
        Me.TextBoxRevocateDate.Visible = True
        Me.TextBoxReasonCode.Visible = True
        Me.LabelSubject.Visible = True
        Me.LabelCountryName.Visible = True
        Me.LabelStateOrProvinceName.Visible = True
        Me.LabelLocalityName.Visible = True
        Me.LabelOrganizationName.Visible = True
        Me.LabelOrganizationUnitName.Visible = True
        Me.LabelCommonName.Visible = True
        Me.LabelEmail.Visible = True
        Me.LabelJICountryName.Visible = True
        Me.LabelJIStateOrProvinceName.Visible = True
        Me.LabelJILocalityName.Visible = True
        Me.LabelJINumber.Visible = True
        Me.LabelStreetAddress.Visible = True
        Me.LabelPostalCode.Visible = True
        Me.LabelBasicConstraints.Visible = True
        Me.LabelCertificatePolicies.Visible = True
        Me.LabelPolicyOID.Visible = True
        Me.LabelCRLDistributionPointos.Visible = True
        Me.LabelAuthorityInfoAccess.Visible = True
        Me.LabelCryptgraphicProviderNames.Visible = True
        Me.LabelKeySize.Visible = True
        Me.LabelCertificateRevocationList.Visible = True
        Me.LabelRevocateDate.Visible = True
        Me.LabelReasonCode.Visible = True
        Me.Panel1.AutoScroll = True
        Me.TableLayoutPanel1.Visible = True
    End Sub

    ' ****** 失効リストの内容を表示します ******
    Private Sub RevoTableDisplay(ByVal SerialNumber As Long)
        Debug.WriteLine("debug 失効リスト番号 [" & SerialNumber.ToString() & "]")
        Me.TextBoxVersion.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordVersion) ' バージョン
        Me.TextBoxSerialNumber.Text = SerialNumber.ToString()          ' シリアル番号
        Me.TextBoxSignatureAlgorithm.Text = Me.RGdata.GetString(SerialNumber, CommonDefines.RecordSignalgo) ' 署名アルゴリズム
        Me.LabelNotBefore.Text = "更新日" ' 有効期間
        Me.LabelNotAfter.Text = "次回更新日"
        Dim ThisUpdate As DateTime = DateTime.Parse(Me.RGdata.GetString(SerialNumber, CommonDefines.RecordThisUpdate))
        Dim NextUpdate As DateTime = DateTime.Parse(Me.RGdata.GetString(SerialNumber, CommonDefines.RecordNextUpdate))
        Me.TextBoxNotBefore.Text = ThisUpdate.ToString("yyyy年 MM月 dd日")
        Me.TextBoxNotAfter.Text = NextUpdate.ToString("yyyy年 MM月 dd日")
        ' Me.TextBoxVersion.Visible = True
        ' Me.TextBoxSerialNumber.Visible = True
        ' Me.TextBoxSignatureAlgorithm.Visible = True
        ' Me.TextBoxNotBefore.Visible = True
        ' Me.TextBoxNotAfter.Visible = True
        Me.TextBoxCountryName.Visible = False
        Me.TextBoxStateOrProvinceName.Visible = False
        Me.TextBoxLocalityName.Visible = False
        Me.TextBoxOrganizationName.Visible = False
        Me.TextBoxOrganizationUnitName.Visible = False
        Me.TextBoxCommonName.Visible = False
        Me.TextBoxEmail.Visible = False
        Me.TextBoxJICountryName.Visible = False
        Me.TextBoxJIStateOrProvinceName.Visible = False
        Me.TextBoxJILocalityName.Visible = False
        Me.TextBoxJINumber.Visible = False
        Me.TextBoxStreetAddress.Visible = False
        Me.TextBoxPostalCode.Visible = False
        Me.TextBoxBasicConstraints.Visible = False
        Me.TextBoxCertificatePolicies.Visible = False
        Me.TextBoxPolicyOID.Visible = False
        Me.TextBoxCRLDistributionPoints.Visible = False
        Me.TextBoxAuthorityInfoAccess.Visible = False
        Me.TextBoxCryptographicProviderNames.Visible = False
        Me.TextBoxKeySize.Visible = False
        Me.TextBoxRevocateDate.Visible = False
        Me.TextBoxReasonCode.Visible = False
        Me.LabelSubject.Visible = False
        Me.LabelCountryName.Visible = False
        Me.LabelStateOrProvinceName.Visible = False
        Me.LabelLocalityName.Visible = False
        Me.LabelOrganizationName.Visible = False
        Me.LabelOrganizationUnitName.Visible = False
        Me.LabelCommonName.Visible = False
        Me.LabelEmail.Visible = False
        Me.LabelJICountryName.Visible = False
        Me.LabelJIStateOrProvinceName.Visible = False
        Me.LabelJILocalityName.Visible = False
        Me.LabelJINumber.Visible = False
        Me.LabelStreetAddress.Visible = False
        Me.LabelPostalCode.Visible = False
        Me.LabelBasicConstraints.Visible = False
        Me.LabelCertificatePolicies.Visible = False
        Me.LabelPolicyOID.Visible = False
        Me.LabelCRLDistributionPointos.Visible = False
        Me.LabelAuthorityInfoAccess.Visible = False
        Me.LabelCryptgraphicProviderNames.Visible = False
        Me.LabelKeySize.Visible = False
        Me.LabelCertificateRevocationList.Visible = False
        Me.LabelRevocateDate.Visible = False
        Me.LabelReasonCode.Visible = False
        Me.Panel1.AutoScroll = False
        Me.TableLayoutPanel1.Visible = True
    End Sub

    ' ****** ツリービューの証明書を選択されたときの処理です ******
    Private Sub TreeView1_AfterSelect(sender As Object, e As TreeViewEventArgs) Handles TreeView1.AfterSelect, TreeView1.AfterCheck
        If Me.TreeMax <> 0 Then
            Dim NodeTitle As String = e.Node.Text
            Dim Deli() As Char = {" "}
            Dim Items() As String = NodeTitle.Split(Deli)
            Dim SerialNumber As Long = Convert.ToInt64(Items(0))
            Dim CertType As String = RGdata.GetCertType(SerialNumber)
            If CertType = CommonDefines.BlockRoot Then                 ' 選択された証明書がルート認証局の場合
                Debug.WriteLine("debug ルート認証局証明書が選択されました。")
                Me.CertTableDisplay(SerialNumber)
            ElseIf CertType = CommonDefines.BlockMiddle Then           ' 選択された証明書が中間認証局の場合
                Debug.WriteLine("debug 中間認証局証明書が選択されました。")
                Me.CertTableDisplay(SerialNumber)
            ElseIf CertType = CommonDefines.BlockUser Then             ' 選択された証明書が個人証明書の場合
                Debug.WriteLine("debug 個人証明書が選択されました。")
                Me.CertTableDisplay(SerialNumber)
            ElseIf CertType = CommonDefines.BlockServer Then           ' 選択された証明書がサーバー証明書の場合
                Debug.WriteLine("debug サーバー証明書が選択されました。")
                Me.CertTableDisplay(SerialNumber)
            ElseIf CertType = CommonDefines.BlockCRL Then              ' 選択された証明書が失効リストの場合
                Debug.WriteLine("debug 失効リストが選択されました。")
                Me.RevoTableDisplay(SerialNumber)
            Else                                                       ' それ以外の場合
                Debug.WriteLine("debug それ以外の証明書が選択されました。")
                Me.CertTableDisplay(SerialNumber)
                ' Me.CertTableClear()
            End If
        Else
            Debug.WriteLine("debug 表示できる証明書がありません。")
        End If
    End Sub

    ' ****** メニューから認証局業務→終了を選択されたときの処理です ******
    Private Sub 終了EToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 終了EToolStripMenuItem.Click
        Debug.WriteLine("debug プログラムを終了します。")
        If Not IsNothing(Me.LOGdata) Then
            LOGdata.Logout("認証局を終了します。")
            LOGdata.Logout("================================================================================")
        End If
        Me.Close()
    End Sub

    ' ****** メニューから認証局業務→ルート認証局の構築を選択されたときの処理です ******
    Private Sub ルート認証局の構築BToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ルート認証局の構築BToolStripMenuItem.Click
        Dim FormCreateCertRoot01 As CreateCertRoot01 = New CreateCertRoot01
        Dim FormCreateCertRoot02 As CreateCertRoot02 = New CreateCertRoot02
        Do
            FormCreateCertRoot01.Location = Me.Location             ' 入力画面を表示します
            FormCreateCertRoot01.ShowDialog()
            If FormCreateCertRoot01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔確認〕が押されました。")
                FormCreateCertRoot02.TextBoxCountryName.Text = FormCreateCertRoot01.TextBoxCountryName.Text
                FormCreateCertRoot02.TextBoxStateOrProvinceName.Text = FormCreateCertRoot01.TextBoxStateOrProvinceName.Text
                FormCreateCertRoot02.TextBoxLocalityName.Text = FormCreateCertRoot01.TextBoxLocalityName.Text
                FormCreateCertRoot02.TextBoxOrganizationName.Text = FormCreateCertRoot01.TextBoxOrganizationName.Text
                FormCreateCertRoot02.TextBoxCommonName.Text = FormCreateCertRoot01.TextBoxCommonName.Text
                FormCreateCertRoot02.TextBoxNotBefore.Text = DateTime.Parse(FormCreateCertRoot01.DateTimePickerNotBefore.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertRoot02.TextBoxNotAfter.Text = DateTime.Parse(FormCreateCertRoot01.DateTimePickerNotAfter.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertRoot02.TextBoxKeysize.Text = FormCreateCertRoot01.ComboBoxKeysize.Text
                FormCreateCertRoot02.TextBoxSignAlgo.Text = FormCreateCertRoot01.ComboBoxSignAlgo.Text
                FormCreateCertRoot02.TextBoxCSP.Text = FormCreateCertRoot01.ComboBoxCSP.Text
                FormCreateCertRoot02.Location = Me.Location            ' 入力確認画面を表示します
                FormCreateCertRoot02.ShowDialog()
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormCreateCertRoot02.CheckOk
        If FormCreateCertRoot02.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormCreateCertRoot03 As CreateCertRoot03 = New CreateCertRoot03 ' 実行します
            FormCreateCertRoot03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormCreateCertRoot03.K9piaExecName = BIdata.K9piaName
            FormCreateCertRoot03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            Dim SNempty As Boolean
            For Retry As Integer = 0 To 10 Step 1
                Dim SNtemp As String = RGdata.GetString(BIdata.SerialNumberRoot, CommonDefines.RecordSirinumber)
                If String.IsNullOrEmpty(SNtemp) Then
                    SNempty = True
                    FormCreateCertRoot03.SerialNumber = BIdata.SerialNumberRoot
                    Exit For
                Else
                    SNempty = False
                    BIdata.NextSerialNumberRoot()
                End If
            Next
            If SNempty Then
                FormCreateCertRoot03.CountryName = FormCreateCertRoot01.TextBoxCountryName.Text
                FormCreateCertRoot03.StateOrProvinceName = FormCreateCertRoot01.TextBoxStateOrProvinceName.Text
                FormCreateCertRoot03.LocalityName = FormCreateCertRoot01.TextBoxLocalityName.Text
                FormCreateCertRoot03.OrganizationName = FormCreateCertRoot01.TextBoxOrganizationName.Text
                FormCreateCertRoot03.CommonName = FormCreateCertRoot01.TextBoxCommonName.Text
                FormCreateCertRoot03.NotBefore = FormCreateCertRoot01.DateTimePickerNotBefore.Value
                FormCreateCertRoot03.NotAfter = FormCreateCertRoot01.DateTimePickerNotAfter.Value
                FormCreateCertRoot03.Keysize = Integer.Parse(FormCreateCertRoot01.ComboBoxKeysize.Text)
                FormCreateCertRoot03.SignAlgo = FormCreateCertRoot01.ComboBoxSignAlgo.Text
                FormCreateCertRoot03.ProviderName = FormCreateCertRoot01.ComboBoxCSP.Text
                FormCreateCertRoot03.RGdata = Me.RGdata
                FormCreateCertRoot03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormCreateCertRoot03.ShowDialog()
                If FormCreateCertRoot03.CheckOk Then
                    Debug.WriteLine("debug 実行画面が終了しました。")
                    Dim FormCreateCertRoot04 As CreateCertRoot04 = New CreateCertRoot04
                    FormCreateCertRoot04.SerialNumber = FormCreateCertRoot03.SerialNumber
                    FormCreateCertRoot04.K9piaCertDirectoryBase = FormCreateCertRoot03.K9piaCertDirectoryBase
                    FormCreateCertRoot04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                    FormCreateCertRoot04.ShowDialog()                      ' 証明書の取得先を表示します

                    BIdata.NextSerialNumberRoot()
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")

                    Me.TreeViewAddAuthority(FormCreateCertRoot04.SerialNumber) ' ツリーを表示します
                    Me.CertTableDisplay(FormCreateCertRoot03.SerialNumber)

                    Me.中間認証局の構築NToolStripMenuItem.Enabled = True
                    Me.個人証明書の作成UToolStripMenuItem.Enabled = True
                    Me.サーバー証明書の作成SToolStripMenuItem.Enabled = True
                    Me.証明書の失効RToolStripMenuItem.Enabled = True
                    Me.失効リストの作成LToolStripMenuItem.Enabled = True
                    Debug.WriteLine("debug すべてのメニューを有効にしました。")
                Else
                    Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
                    BIdata.NextSerialNumberRoot()                      ' シリアル番号を欠番にする
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                End If
            Else
                Dim msg As String = "シリアル番号に空きが見つかりませんでした。"
                msg &= "処理を中止します。"
                MessageBox.Show(msg, "システムエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→中間認証局の構築を選択されたときの処理です ******
    Private Sub 中間認証局の構築NToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 中間認証局の構築NToolStripMenuItem.Click
        Dim FormCreateCertMiddle01 As CreateCertMiddle01 = New CreateCertMiddle01
        Dim FormCreateCertMiddle02 As CreateCertMiddle02 = New CreateCertMiddle02
        FormCreateCertMiddle01.RGdata = Me.RGdata
        Do
            FormCreateCertMiddle01.Location = Me.Location              ' 入力画面を表示します
            FormCreateCertMiddle01.ShowDialog()
            If FormCreateCertMiddle01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔確認〕が押されました。")
                FormCreateCertMiddle02.TextBoxAuthority.Text = FormCreateCertMiddle01.ComboBoxAuthority.Text
                FormCreateCertMiddle02.TextBoxCountryName.Text = FormCreateCertMiddle01.TextBoxCountryName.Text
                FormCreateCertMiddle02.TextBoxStateOrProvinceName.Text = FormCreateCertMiddle01.TextBoxStateOrProvinceName.Text
                FormCreateCertMiddle02.TextBoxLocalityName.Text = FormCreateCertMiddle01.TextBoxLocalityName.Text
                FormCreateCertMiddle02.TextBoxOrganizationName.Text = FormCreateCertMiddle01.TextBoxOrganizationName.Text
                FormCreateCertMiddle02.TextBoxOrganizationUnitName.Text = FormCreateCertMiddle01.TextBoxOrganizationUnitName.Text
                FormCreateCertMiddle02.TextBoxCommonName.Text = FormCreateCertMiddle01.TextBoxCommonName.Text
                FormCreateCertMiddle02.TextBoxNotBefore.Text = DateTime.Parse(FormCreateCertMiddle01.DateTimePickerNotBefore.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertMiddle02.TextBoxNotAfter.Text = DateTime.Parse(FormCreateCertMiddle01.DateTimePickerNotAfter.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertMiddle02.TextBoxCertificatePolicies.Text = FormCreateCertMiddle01.TextBoxCertificatePolicies.Text
                If FormCreateCertMiddle01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertMiddle02.LabelAnyPolicy.Text = "● AnyPolicy"
                    FormCreateCertMiddle02.LabelPolicyOID.Text = "○"
                    FormCreateCertMiddle02.TextBoxPolicyOID.Text = ""
                Else
                    FormCreateCertMiddle02.LabelAnyPolicy.Text = "○ AnyPolicy"
                    FormCreateCertMiddle02.LabelPolicyOID.Text = "●"
                    FormCreateCertMiddle02.TextBoxPolicyOID.Text = FormCreateCertMiddle01.TextBoxPolicyOID.Text
                End If
                FormCreateCertMiddle02.TextBoxCRLDistributionPoints.Text = FormCreateCertMiddle01.TextBoxCRLDistributionPoints.Text
                FormCreateCertMiddle02.TextBoxAuthorityInfoAccess.Text = FormCreateCertMiddle01.TextBoxAuthorityInfoAccess.Text
                If FormCreateCertMiddle01.CheckBoxPathlen.Checked Then
                    FormCreateCertMiddle02.LabelPathlen.Text = "■ この認証局に下位の認証局構築を許可する"
                    FormCreateCertMiddle02.TextBoxPathlen.Text = FormCreateCertMiddle01.TextBoxPathlen.Text
                Else
                    FormCreateCertMiddle02.LabelPathlen.Text = "□ この認証局に下位の認証局構築を許可する"
                    FormCreateCertMiddle02.TextBoxPathlen.Text = ""
                End If
                FormCreateCertMiddle02.TextBoxKeysize.Text = FormCreateCertMiddle01.ComboBoxKeysize.Text
                FormCreateCertMiddle02.TextBoxSignAlgo.Text = FormCreateCertMiddle01.TextBoxSignAlgo.Text
                FormCreateCertMiddle02.TextBoxCSP.Text = FormCreateCertMiddle01.ComboBoxCSP.Text
                FormCreateCertMiddle02.Location = Me.Location          ' 入力確認画面を表示します
                FormCreateCertMiddle02.ShowDialog()
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormCreateCertMiddle02.CheckOk
        If FormCreateCertMiddle02.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormCreateCertMiddle03 As CreateCertMiddle03 = New CreateCertMiddle03 ' 実行します
            FormCreateCertMiddle03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormCreateCertMiddle03.K9piaExecName = BIdata.K9piaName
            FormCreateCertMiddle03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormCreateCertMiddle03.Issuer = FormCreateCertMiddle01.AuthList.SerialNumber(FormCreateCertMiddle01.ComboBoxAuthority.SelectedIndex)
            Dim SNempty As Boolean
            For Retry As Integer = 0 To 10 Step 1
                Dim SNtemp As String = RGdata.GetString(BIdata.SerialNumberMiddle, CommonDefines.RecordSirinumber)
                If String.IsNullOrEmpty(SNtemp) Then
                    SNempty = True
                    FormCreateCertMiddle03.SerialNumber = BIdata.SerialNumberMiddle
                    Exit For
                Else
                    SNempty = False
                    BIdata.NextSerialNumberMiddle()
                End If
            Next
            If SNempty Then
                FormCreateCertMiddle03.CountryName = FormCreateCertMiddle01.TextBoxCountryName.Text
                FormCreateCertMiddle03.StateOrProvinceName = FormCreateCertMiddle01.TextBoxStateOrProvinceName.Text
                FormCreateCertMiddle03.LocalityName = FormCreateCertMiddle01.TextBoxLocalityName.Text
                FormCreateCertMiddle03.OrganizationName = FormCreateCertMiddle01.TextBoxOrganizationName.Text
                FormCreateCertMiddle03.OrganizationUnitName = FormCreateCertMiddle01.TextBoxOrganizationUnitName.Text
                FormCreateCertMiddle03.CommonName = FormCreateCertMiddle01.TextBoxCommonName.Text
                FormCreateCertMiddle03.NotBefore = FormCreateCertMiddle01.DateTimePickerNotBefore.Value
                FormCreateCertMiddle03.NotAfter = FormCreateCertMiddle01.DateTimePickerNotAfter.Value
                FormCreateCertMiddle03.CertificatePolicies = FormCreateCertMiddle01.TextBoxCertificatePolicies.Text
                If FormCreateCertMiddle01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertMiddle03.AnyPolicyUsed = True
                    FormCreateCertMiddle03.PolicyOID = ""
                Else
                    FormCreateCertMiddle03.AnyPolicyUsed = False
                    FormCreateCertMiddle03.PolicyOID = FormCreateCertMiddle01.TextBoxPolicyOID.Text
                End If
                FormCreateCertMiddle03.CRLDistributionPoints = FormCreateCertMiddle01.TextBoxCRLDistributionPoints.Text
                FormCreateCertMiddle03.AuthorityInfoAccess = FormCreateCertMiddle01.TextBoxAuthorityInfoAccess.Text
                If FormCreateCertMiddle01.CheckBoxPathlen.Checked Then
                    FormCreateCertMiddle03.Pathlen = Integer.Parse(FormCreateCertMiddle01.TextBoxPathlen.Text)
                Else
                    FormCreateCertMiddle03.Pathlen = -1
                End If
                FormCreateCertMiddle03.Keysize = Integer.Parse(FormCreateCertMiddle01.ComboBoxKeysize.Text)
                FormCreateCertMiddle03.SignAlgo = FormCreateCertMiddle01.TextBoxSignAlgo.Text
                FormCreateCertMiddle03.ProviderName = FormCreateCertMiddle01.ComboBoxCSP.Text
                FormCreateCertMiddle03.RGdata = Me.RGdata
                FormCreateCertMiddle03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormCreateCertMiddle03.ShowDialog()
                If FormCreateCertMiddle03.CheckOk Then
                    Debug.WriteLine("debug 実行画面が終了しました。")
                    Dim FormCreateCertMiddle04 As CreateCertMiddle04 = New CreateCertMiddle04
                    FormCreateCertMiddle04.SerialNumber = FormCreateCertMiddle03.SerialNumber
                    FormCreateCertMiddle04.K9piaCertDirectoryBase = FormCreateCertMiddle03.K9piaCertDirectoryBase
                    FormCreateCertMiddle04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                    FormCreateCertMiddle04.ShowDialog()                      ' 証明書の取得先を表示します

                    BIdata.NextSerialNumberMiddle()
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")

                    Me.TreeViewAddAuthority(FormCreateCertMiddle04.SerialNumber) ' ツリーを表示します
                Else
                    Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
                    BIdata.NextSerialNumberMiddle()                    ' シリアル番号を欠番にする
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                End If
            Else
                Dim msg As String = "シリアル番号に空きが見つかりませんでした。"
                msg &= "処理を中止します。"
                MessageBox.Show(msg, "システムエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→認証局のインポートを選択されたときの処理です ******
    Private Sub 認証局のインポートIToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 認証局のインポートIToolStripMenuItem.Click
        Dim FormImportCertMiddle01 As ImportCertMiddle01 = New ImportCertMiddle01
        FormImportCertMiddle01.Location = Me.Location                  ' 入力画面を表示します
        FormImportCertMiddle01.RGdata = Me.RGdata
        FormImportCertMiddle01.ShowDialog()
        If FormImportCertMiddle01.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormImportCertMiddle03 As ImportCertMiddle03 = New ImportCertMiddle03 ' 実行します
            FormImportCertMiddle03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormImportCertMiddle03.K9piaExecName = BIdata.K9piaName
            FormImportCertMiddle03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormImportCertMiddle03.DirectoryName = FormImportCertMiddle01.DirectoryName
            FormImportCertMiddle03.FileName = FormImportCertMiddle01.FileName
            FormImportCertMiddle03.FileExtend = FormImportCertMiddle01.FileExtend
            FormImportCertMiddle03.Password = FormImportCertMiddle01.TextBoxPassword.Text
            FormImportCertMiddle03.KeyExist = FormImportCertMiddle01.KeyExist
            FormImportCertMiddle03.SerialNumber = Convert.ToInt64(FormImportCertMiddle01.TextBoxSerialNumber.Text, 16)
            FormImportCertMiddle03.CountryName = FormImportCertMiddle01.TextBoxCountryName.Text
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxStateOrProvinceName.Text) Then
                FormImportCertMiddle03.StateOrProvinceName = FormImportCertMiddle01.TextBoxStateOrProvinceName.Text
            End If
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxLocalityName.Text) Then
                FormImportCertMiddle03.LocalityName = FormImportCertMiddle01.TextBoxLocalityName.Text
            End If
            FormImportCertMiddle03.OrganizationName = FormImportCertMiddle01.TextBoxOrganizationName.Text
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxOrganizationUnitName.Text) Then
                FormImportCertMiddle03.OrganizationUnitName = FormImportCertMiddle01.TextBoxOrganizationUnitName.Text
            End If
            FormImportCertMiddle03.CommonName = FormImportCertMiddle01.TextBoxCommonName.Text
            FormImportCertMiddle03.NotBefore = DateTime.Parse(FormImportCertMiddle01.TextBoxNotBefore.Text)
            FormImportCertMiddle03.NotAfter = DateTime.Parse(FormImportCertMiddle01.TextBoxNotAfter.Text)
            If FormImportCertMiddle01.TextBoxBasicConstraints.Text = "認証局" Then
                FormImportCertMiddle03.BasicConst = True
                If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxPathlen.Text) Then
                    If FormImportCertMiddle01.TextBoxPathlen.Text = "-" Then
                        FormImportCertMiddle03.Pathlen = -1
                    Else
                        FormImportCertMiddle03.Pathlen = Integer.Parse(FormImportCertMiddle01.TextBoxPathlen.Text)
                    End If
                Else
                    FormImportCertMiddle03.Pathlen = -1
                End If
            Else
                FormImportCertMiddle03.BasicConst = False
                FormImportCertMiddle03.Pathlen = -1
            End If
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxCertificatePolicies.Text) Then
                FormImportCertMiddle03.CertificatePolicies = FormImportCertMiddle01.TextBoxCertificatePolicies.Text
                If FormImportCertMiddle01.TextBoxPolicyOID.Text = CommonDefines.K9anyP Then
                    FormImportCertMiddle03.AnyPolicyUsed = True
                    FormImportCertMiddle03.PolicyOID = ""
                Else
                    FormImportCertMiddle03.AnyPolicyUsed = False
                    FormImportCertMiddle03.PolicyOID = FormImportCertMiddle01.TextBoxPolicyOID.Text
                End If
            End If
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxCRLDistributionPoints.Text) Then
                FormImportCertMiddle03.CRLDistributionPoints = FormImportCertMiddle01.TextBoxCRLDistributionPoints.Text
            End If
            If Not String.IsNullOrEmpty(FormImportCertMiddle01.TextBoxAuthorityInfoAccess.Text) Then
                FormImportCertMiddle03.AuthorityInfoAccess = FormImportCertMiddle01.TextBoxAuthorityInfoAccess.Text
            End If
            FormImportCertMiddle03.Keysize = Integer.Parse(FormImportCertMiddle01.TextBoxKeysize.Text)
            If FormImportCertMiddle01.TextBoxSignatureAlgorithm.Text = CommonDefines.K9sha1API Then
                FormImportCertMiddle03.SignAlgo = CommonDefines.K9sha1
            ElseIf FormImportCertMiddle01.TextBoxSignatureAlgorithm.Text = CommonDefines.K9sha2API Then
                FormImportCertMiddle03.SignAlgo = CommonDefines.K9sha2
            Else
                FormImportCertMiddle03.SignAlgo = CommonDefines.K9sha1
            End If
            FormImportCertMiddle03.RGdata = Me.RGdata
            FormImportCertMiddle03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
            FormImportCertMiddle03.ShowDialog()
            If FormImportCertMiddle03.CheckOk Then
                Debug.WriteLine("debug 実行画面が終了しました。")
                Dim FormImportCertMiddle04 As CreateCertMiddle04 = New CreateCertMiddle04
                FormImportCertMiddle04.SerialNumber = FormImportCertMiddle03.SerialNumber
                FormImportCertMiddle04.K9piaCertDirectoryBase = FormImportCertMiddle03.K9piaCertDirectoryBase
                FormImportCertMiddle04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormImportCertMiddle04.ShowDialog()                    ' 証明書の取得先を表示します

                BIdata.WriteFile()
                Debug.WriteLine("debug 基本情報ファイルを更新しました。")

                Me.TreeViewAddAuthority(FormImportCertMiddle04.SerialNumber) ' ツリーを表示します

                Me.中間認証局の構築NToolStripMenuItem.Enabled = True
                Me.個人証明書の作成UToolStripMenuItem.Enabled = True
                Me.サーバー証明書の作成SToolStripMenuItem.Enabled = True
                Me.証明書の失効RToolStripMenuItem.Enabled = True
                Me.失効リストの作成LToolStripMenuItem.Enabled = True
                Debug.WriteLine("debug すべてのメニューを有効にしました。")
            Else
                Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→個人証明書の作成を選択されたときの処理です ******
    Private Sub 個人証明書の作成UToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 個人証明書の作成UToolStripMenuItem.Click
        Dim FormCreateCertUser01 As CreateCertUser01 = New CreateCertUser01
        Dim FormCreateCertUser02 As CreateCertUser02 = New CreateCertUser02
        FormCreateCertUser01.RGdata = Me.RGdata
        Do
            FormCreateCertUser01.Location = Me.Location                ' 入力画面を表示します
            FormCreateCertUser01.ShowDialog()
            If FormCreateCertUser01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔確認〕が押されました。")
                FormCreateCertUser02.TextBoxAuthority.Text = FormCreateCertUser01.ComboBoxAuthority.Text
                FormCreateCertUser02.TextBoxFilename.Text = FormCreateCertUser01.TextBoxFilename.Text
                FormCreateCertUser02.TextBoxCountryName.Text = FormCreateCertUser01.TextBoxCountryName.Text
                FormCreateCertUser02.TextBoxStateOrProvinceName.Text = FormCreateCertUser01.TextBoxStateOrProvinceName.Text
                FormCreateCertUser02.TextBoxLocalityName.Text = FormCreateCertUser01.TextBoxLocalityName.Text
                FormCreateCertUser02.TextBoxOrganizationName.Text = FormCreateCertUser01.TextBoxOrganizationName.Text
                FormCreateCertUser02.TextBoxOrganizationUnitName.Text = FormCreateCertUser01.TextBoxOrganizationUnitName.Text
                FormCreateCertUser02.TextBoxCommonName.Text = FormCreateCertUser01.TextBoxCommonName.Text
                FormCreateCertUser02.TextBoxEmail.Text = FormCreateCertUser01.TextBoxEmail.Text
                FormCreateCertUser02.TextBoxNotBefore.Text = DateTime.Parse(FormCreateCertUser01.DateTimePickerNotBefore.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertUser02.TextBoxNotAfter.Text = DateTime.Parse(FormCreateCertUser01.DateTimePickerNotAfter.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertUser02.TextBoxCertificatePolicies.Text = FormCreateCertUser01.TextBoxCertificatePolicies.Text
                If FormCreateCertUser01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertUser02.LabelAnyPolicy.Text = "● AnyPolicy"
                    FormCreateCertUser02.LabelPolicyOID.Text = "○"
                    FormCreateCertUser02.TextBoxPolicyOID.Text = ""
                Else
                    FormCreateCertUser02.LabelAnyPolicy.Text = "○ AnyPolicy"
                    FormCreateCertUser02.LabelPolicyOID.Text = "●"
                    FormCreateCertUser02.TextBoxPolicyOID.Text = FormCreateCertUser01.TextBoxPolicyOID.Text
                End If
                FormCreateCertUser02.TextBoxCRLDistributionPoints.Text = FormCreateCertUser01.TextBoxCRLDistributionPoints.Text
                FormCreateCertUser02.TextBoxAuthorityInfoAccess.Text = FormCreateCertUser01.TextBoxAuthorityInfoAccess.Text
                FormCreateCertUser02.TextBoxPicture.Text = FormCreateCertUser01.TextBoxPicture.Text
                If String.IsNullOrEmpty(FormCreateCertUser01.TextBoxPassword.Text) Then
                    FormCreateCertUser02.TextBoxPassword.Text = ""
                Else
                    Dim LenTemp As Integer = FormCreateCertUser01.TextBoxPassword.TextLength
                    FormCreateCertUser02.TextBoxPassword.Text = StrDup(LenTemp, "*")
                End If
                FormCreateCertUser02.TextBoxKeysize.Text = FormCreateCertUser01.ComboBoxKeysize.Text
                FormCreateCertUser02.TextBoxSignAlgo.Text = FormCreateCertUser01.TextBoxSignAlgo.Text
                FormCreateCertUser02.TextBoxCSP.Text = FormCreateCertUser01.ComboBoxCSP.Text
                If FormCreateCertUser01.CheckBoxWithCert.Checked Then
                    FormCreateCertUser02.LabelWithCert.Text = "■ 同梱する"
                Else
                    FormCreateCertUser02.LabelWithCert.Text = "□ 同梱する"
                End If
                If FormCreateCertUser01.ComboBoxSSLclient.Text = "SSLrequireファイルを作成する (Apache用)" Then
                    FormCreateCertUser02.TextBoxSSLrequire.Text = "SSLrequireファイルを作成する (Apache用)"
                ElseIf FormCreateCertUser01.ComboBoxSSLclient.Text = "マッピング内容を出力する (IIS7用)" Then
                    FormCreateCertUser02.TextBoxSSLrequire.Text = "マッピング内容を出力する (IIS7用)"
                Else
                    FormCreateCertUser02.TextBoxSSLrequire.Text = "SSLクライアント認証を行わない"
                End If
                FormCreateCertUser02.Location = Me.Location          ' 入力確認画面を表示します
                FormCreateCertUser02.ShowDialog()
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormCreateCertUser02.CheckOk
        If FormCreateCertUser02.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormCreateCertUser03 As CreateCertUser03 = New CreateCertUser03 ' 実行します
            FormCreateCertUser03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormCreateCertUser03.K9piaExecName = BIdata.K9piaName
            FormCreateCertUser03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormCreateCertUser03.Issuer = FormCreateCertUser01.AuthList.SerialNumber(FormCreateCertUser01.ComboBoxAuthority.SelectedIndex)
            Dim SNempty As Boolean
            For Retry As Integer = 0 To 10 Step 1
                Dim SNtemp As String = RGdata.GetString(BIdata.SerialNumberUser, CommonDefines.RecordSirinumber)
                If String.IsNullOrEmpty(SNtemp) Then
                    SNempty = True
                    FormCreateCertUser03.SerialNumber = BIdata.SerialNumberUser
                    Exit For
                Else
                    SNempty = False
                    BIdata.NextSerialNumberUser()
                End If
            Next
            If SNempty Then
                FormCreateCertUser03.CSRfilename = FormCreateCertUser01.TextBoxFilename.Text
                FormCreateCertUser03.CountryName = FormCreateCertUser01.TextBoxCountryName.Text
                FormCreateCertUser03.StateOrProvinceName = FormCreateCertUser01.TextBoxStateOrProvinceName.Text
                FormCreateCertUser03.LocalityName = FormCreateCertUser01.TextBoxLocalityName.Text
                FormCreateCertUser03.OrganizationName = FormCreateCertUser01.TextBoxOrganizationName.Text
                FormCreateCertUser03.OrganizationUnitName = FormCreateCertUser01.TextBoxOrganizationUnitName.Text
                FormCreateCertUser03.CommonName = FormCreateCertUser01.TextBoxCommonName.Text
                FormCreateCertUser03.Email = FormCreateCertUser01.TextBoxEmail.Text
                FormCreateCertUser03.NotBefore = FormCreateCertUser01.DateTimePickerNotBefore.Value
                FormCreateCertUser03.NotAfter = FormCreateCertUser01.DateTimePickerNotAfter.Value
                FormCreateCertUser03.CertificatePolicies = FormCreateCertUser01.TextBoxCertificatePolicies.Text
                If FormCreateCertUser01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertUser03.AnyPolicyUsed = True
                    FormCreateCertUser03.PolicyOID = ""
                Else
                    FormCreateCertUser03.AnyPolicyUsed = False
                    FormCreateCertUser03.PolicyOID = FormCreateCertUser01.TextBoxPolicyOID.Text
                End If
                FormCreateCertUser03.CRLDistributionPoints = FormCreateCertUser01.TextBoxCRLDistributionPoints.Text
                FormCreateCertUser03.AuthorityInfoAccess = FormCreateCertUser01.TextBoxAuthorityInfoAccess.Text
                FormCreateCertUser03.Picture = FormCreateCertUser01.TextBoxPicture.Text
                FormCreateCertUser03.Password = FormCreateCertUser01.TextBoxPassword.Text
                FormCreateCertUser03.Keysize = Integer.Parse(FormCreateCertUser01.ComboBoxKeysize.Text)
                FormCreateCertUser03.SignAlgo = FormCreateCertUser01.TextBoxSignAlgo.Text
                FormCreateCertUser03.ProviderName = FormCreateCertUser01.ComboBoxCSP.Text
                If FormCreateCertUser01.CheckBoxWithCert.Checked Then
                    FormCreateCertUser03.WithCert = True
                Else
                    FormCreateCertUser03.WithCert = False
                End If
                If FormCreateCertUser01.ComboBoxSSLclient.Text = "SSLrequireファイルを作成する (Apache用)" Then
                    FormCreateCertUser03.SSLrequire = CommonDefines.K9sslApache
                ElseIf FormCreateCertUser01.ComboBoxSSLclient.Text = "マッピング内容を出力する (IIS7用)" Then
                    FormCreateCertUser03.SSLrequire = CommonDefines.K9sslIIS7
                Else
                    FormCreateCertUser03.SSLrequire = 0
                End If
                FormCreateCertUser03.RGdata = Me.RGdata
                FormCreateCertUser03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormCreateCertUser03.ShowDialog()
                If FormCreateCertUser03.CheckOk Then
                    Debug.WriteLine("debug 実行画面が終了しました。")
                    Dim FormCreateCertUser04 As CreateCertUser04 = New CreateCertUser04
                    FormCreateCertUser04.Issuer = FormCreateCertUser01.AuthList.SerialNumber(FormCreateCertUser01.ComboBoxAuthority.SelectedIndex)
                    FormCreateCertUser04.SerialNumber = FormCreateCertUser03.SerialNumber
                    FormCreateCertUser04.K9piaCertDirectoryBase = FormCreateCertUser03.K9piaCertDirectoryBase
                    If String.IsNullOrEmpty(FormCreateCertUser01.TextBoxFilename.Text) Then
                        If FormCreateCertUser01.ComboBoxCSP.Text = CommonDefines.K9cspJpk Then
                            FormCreateCertUser04.OutExt1st = CommonDefines.K9extCER
                        Else
                            FormCreateCertUser04.OutExt1st = CommonDefines.K9extP12
                        End If
                    Else
                        FormCreateCertUser04.OutExt1st = CommonDefines.K9extCER
                    End If
                    FormCreateCertUser04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                    FormCreateCertUser04.ShowDialog()                      ' 証明書の取得先を表示します

                    BIdata.NextSerialNumberUser()
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                    '                                                        ツリーを表示します
                    Me.TreeViewAddUser(FormCreateCertUser04.SerialNumber, FormCreateCertUser04.Issuer)
                Else
                    Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
                    BIdata.NextSerialNumberUser()                      ' シリアル番号を欠番にする
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                End If
            Else
                Dim msg As String = "シリアル番号に空きが見つかりませんでした。"
                msg &= "処理を中止します。"
                MessageBox.Show(msg, "システムエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→サーバー証明書の作成を選択されたときの処理です ******
    Private Sub サーバー証明書の作成SToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles サーバー証明書の作成SToolStripMenuItem.Click
        Dim FormCreateCertServer01 As CreateCertServer01 = New CreateCertServer01
        Dim FormCreateCertServer02 As CreateCertServer02 = New CreateCertServer02
        FormCreateCertServer01.RGdata = Me.RGdata
        Do
            FormCreateCertServer01.Location = Me.Location                ' 入力画面を表示します
            FormCreateCertServer01.ShowDialog()
            If FormCreateCertServer01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔確認〕が押されました。")
                FormCreateCertServer02.TextBoxAuthority.Text = FormCreateCertServer01.ComboBoxAuthority.Text
                FormCreateCertServer02.TextBoxFilename.Text = FormCreateCertServer01.TextBoxFilename.Text
                FormCreateCertServer02.TextBoxCountryName.Text = FormCreateCertServer01.TextBoxCountryName.Text
                FormCreateCertServer02.TextBoxStateOrProvinceName.Text = FormCreateCertServer01.TextBoxStateOrProvinceName.Text
                FormCreateCertServer02.TextBoxLocalityName.Text = FormCreateCertServer01.TextBoxLocalityName.Text
                FormCreateCertServer02.TextBoxOrganizationName.Text = FormCreateCertServer01.TextBoxOrganizationName.Text
                FormCreateCertServer02.TextBoxOrganizationUnitName.Text = FormCreateCertServer01.TextBoxOrganizationUnitName.Text
                FormCreateCertServer02.TextBoxCommonName.Text = FormCreateCertServer01.TextBoxCommonName.Text
                FormCreateCertServer02.TextBoxStreet.Text = FormCreateCertServer01.TextBoxStreet.Text
                FormCreateCertServer02.TextBoxPostalCode.Text = FormCreateCertServer01.TextBoxPostalCode.Text
                FormCreateCertServer02.TextBoxJIcountryName.Text = FormCreateCertServer01.TextBoxJIcountryName.Text
                FormCreateCertServer02.TextBoxJIstateOrProvinceName.Text = FormCreateCertServer01.TextBoxJIstateOrProvinceName.Text
                FormCreateCertServer02.TextBoxJIlocalityName.Text = FormCreateCertServer01.TextBoxJIlocalityName.Text
                FormCreateCertServer02.TextBoxJInumber.Text = FormCreateCertServer01.TextBoxJInumber.Text
                FormCreateCertServer02.TextBoxNotBefore.Text = DateTime.Parse(FormCreateCertServer01.DateTimePickerNotBefore.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertServer02.TextBoxNotAfter.Text = DateTime.Parse(FormCreateCertServer01.DateTimePickerNotAfter.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormCreateCertServer02.TextBoxCertificatePolicies.Text = FormCreateCertServer01.TextBoxCertificatePolicies.Text
                If FormCreateCertServer01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertServer02.LabelAnyPolicy.Text = "● AnyPolicy"
                    FormCreateCertServer02.LabelPolicyOID.Text = "○"
                    FormCreateCertServer02.TextBoxPolicyOID.Text = ""
                Else
                    FormCreateCertServer02.LabelAnyPolicy.Text = "○ AnyPolicy"
                    FormCreateCertServer02.LabelPolicyOID.Text = "●"
                    FormCreateCertServer02.TextBoxPolicyOID.Text = FormCreateCertServer01.TextBoxPolicyOID.Text
                End If
                FormCreateCertServer02.TextBoxCRLDistributionPoints.Text = FormCreateCertServer01.TextBoxCRLDistributionPoints.Text
                FormCreateCertServer02.TextBoxAuthorityInfoAccess.Text = FormCreateCertServer01.TextBoxAuthorityInfoAccess.Text
                If FormCreateCertServer01.RadioButtonIIS.Checked Then
                    FormCreateCertServer02.LabelIIS.Text = "● IIS"
                    FormCreateCertServer02.LabelApache.Text = "○ Apache"
                Else
                    FormCreateCertServer02.LabelIIS.Text = "○ IIS"
                    FormCreateCertServer02.LabelApache.Text = "● Apache"
                End If
                If String.IsNullOrEmpty(FormCreateCertServer01.TextBoxPassword.Text) Then
                    FormCreateCertServer02.TextBoxPassword.Text = ""
                Else
                    Dim LenTemp As Integer = FormCreateCertServer01.TextBoxPassword.TextLength
                    FormCreateCertServer02.TextBoxPassword.Text = StrDup(LenTemp, "*")
                End If
                FormCreateCertServer02.TextBoxKeysize.Text = FormCreateCertServer01.ComboBoxKeysize.Text
                FormCreateCertServer02.TextBoxSignAlgo.Text = FormCreateCertServer01.TextBoxSignAlgo.Text
                FormCreateCertServer02.TextBoxCSP.Text = FormCreateCertServer01.ComboBoxCSP.Text
                FormCreateCertServer02.Location = Me.Location          ' 入力確認画面を表示します
                FormCreateCertServer02.ShowDialog()
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormCreateCertServer02.CheckOk
        If FormCreateCertServer02.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormCreateCertServer03 As CreateCertServer03 = New CreateCertServer03 ' 実行します
            FormCreateCertServer03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormCreateCertServer03.K9piaExecName = BIdata.K9piaName
            FormCreateCertServer03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormCreateCertServer03.Issuer = FormCreateCertServer01.AuthList.SerialNumber(FormCreateCertServer01.ComboBoxAuthority.SelectedIndex)
            Dim SNempty As Boolean
            For Retry As Integer = 0 To 10 Step 1
                Dim SNtemp As String = RGdata.GetString(BIdata.SerialNumberServer, CommonDefines.RecordSirinumber)
                If String.IsNullOrEmpty(SNtemp) Then
                    SNempty = True
                    FormCreateCertServer03.SerialNumber = BIdata.SerialNumberServer
                    Exit For
                Else
                    SNempty = False
                    BIdata.NextSerialNumberServer()
                End If
            Next
            If SNempty Then
                FormCreateCertServer03.CSRfilename = FormCreateCertServer01.TextBoxFilename.Text
                FormCreateCertServer03.CountryName = FormCreateCertServer01.TextBoxCountryName.Text
                FormCreateCertServer03.StateOrProvinceName = FormCreateCertServer01.TextBoxStateOrProvinceName.Text
                FormCreateCertServer03.LocalityName = FormCreateCertServer01.TextBoxLocalityName.Text
                FormCreateCertServer03.OrganizationName = FormCreateCertServer01.TextBoxOrganizationName.Text
                FormCreateCertServer03.OrganizationUnitName = FormCreateCertServer01.TextBoxOrganizationUnitName.Text
                FormCreateCertServer03.CommonName = FormCreateCertServer01.TextBoxCommonName.Text
                FormCreateCertServer03.Street = FormCreateCertServer01.TextBoxStreet.Text
                FormCreateCertServer03.PostalCode = FormCreateCertServer01.TextBoxPostalCode.Text
                FormCreateCertServer03.JIcountryName = FormCreateCertServer01.TextBoxJIcountryName.Text
                FormCreateCertServer03.JIstateOrProvinceName = FormCreateCertServer01.TextBoxJIstateOrProvinceName.Text
                FormCreateCertServer03.JIlocalityName = FormCreateCertServer01.TextBoxJIlocalityName.Text
                FormCreateCertServer03.JInumber = FormCreateCertServer01.TextBoxJInumber.Text
                FormCreateCertServer03.NotBefore = FormCreateCertServer01.DateTimePickerNotBefore.Value
                FormCreateCertServer03.NotAfter = FormCreateCertServer01.DateTimePickerNotAfter.Value
                FormCreateCertServer03.CertificatePolicies = FormCreateCertServer01.TextBoxCertificatePolicies.Text
                If FormCreateCertServer01.RadioButtonAnyPolicy.Checked Then
                    FormCreateCertServer03.AnyPolicyUsed = True
                    FormCreateCertServer03.PolicyOID = ""
                Else
                    FormCreateCertServer03.AnyPolicyUsed = False
                    FormCreateCertServer03.PolicyOID = FormCreateCertServer01.TextBoxPolicyOID.Text
                End If
                FormCreateCertServer03.CRLDistributionPoints = FormCreateCertServer01.TextBoxCRLDistributionPoints.Text
                FormCreateCertServer03.AuthorityInfoAccess = FormCreateCertServer01.TextBoxAuthorityInfoAccess.Text
                If FormCreateCertServer01.RadioButtonIIS.Checked Then
                    FormCreateCertServer03.ServerType = True
                Else
                    FormCreateCertServer03.ServerType = False
                End If
                FormCreateCertServer03.Password = FormCreateCertServer01.TextBoxPassword.Text
                FormCreateCertServer03.Keysize = Integer.Parse(FormCreateCertServer01.ComboBoxKeysize.Text)
                FormCreateCertServer03.SignAlgo = FormCreateCertServer01.TextBoxSignAlgo.Text
                FormCreateCertServer03.ProviderName = FormCreateCertServer01.ComboBoxCSP.Text
                FormCreateCertServer03.RGdata = Me.RGdata
                FormCreateCertServer03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormCreateCertServer03.ShowDialog()
                If FormCreateCertServer03.CheckOk Then
                    Debug.WriteLine("debug 実行画面が終了しました。")
                    Dim FormCreateCertServer04 As CreateCertServer04 = New CreateCertServer04
                    FormCreateCertServer04.Issuer = FormCreateCertServer01.AuthList.SerialNumber(FormCreateCertServer01.ComboBoxAuthority.SelectedIndex)
                    FormCreateCertServer04.SerialNumber = FormCreateCertServer03.SerialNumber
                    FormCreateCertServer04.K9piaCertDirectoryBase = FormCreateCertServer03.K9piaCertDirectoryBase
                    If String.IsNullOrEmpty(FormCreateCertServer01.TextBoxFilename.Text) Then
                        If FormCreateCertServer01.RadioButtonIIS.Checked Then
                            If FormCreateCertServer01.ComboBoxCSP.Text = CommonDefines.K9cspJpk Then
                                FormCreateCertServer04.OutExt1st = CommonDefines.K9extCER
                                FormCreateCertServer04.OutExt2nd = Nothing
                            Else
                                FormCreateCertServer04.OutExt1st = CommonDefines.K9extPFX
                                FormCreateCertServer04.OutExt2nd = Nothing
                            End If
                        Else
                            FormCreateCertServer04.OutExt1st = CommonDefines.K9extCER
                            FormCreateCertServer04.OutExt2nd = CommonDefines.K9extKEY
                        End If
                    Else
                        FormCreateCertServer04.OutExt1st = CommonDefines.K9extCER
                        FormCreateCertServer04.OutExt2nd = Nothing
                    End If
                    FormCreateCertServer04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                    FormCreateCertServer04.ShowDialog()                      ' 証明書の取得先を表示します

                    BIdata.NextSerialNumberServer()
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                    '                                                        ツリーを表示します
                    Me.TreeViewAddUser(FormCreateCertServer04.SerialNumber, FormCreateCertServer04.Issuer)
                Else
                    Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
                    BIdata.NextSerialNumberServer()                    ' シリアル番号を欠番にする
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                End If
            Else
                Dim msg As String = "シリアル番号に空きが見つかりませんでした。"
                msg &= "処理を中止します。"
                MessageBox.Show(msg, "システムエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→証明書の失効を選択されたときの処理です ******
    Private Sub 証明書の失効RToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 証明書の失効RToolStripMenuItem.Click
        Dim FormRevocateCert01 As RevocateCert01 = New RevocateCert01
        Dim FormRevocateCert02 As RevocateCert02 = New RevocateCert02
        Dim RevoCount As Integer = 0
        FormRevocateCert01.RGdata = Me.RGdata
        Do
            FormRevocateCert01.Location = Me.Location                ' 入力画面を表示します
            FormRevocateCert01.ShowDialog()
            If FormRevocateCert01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔確認〕が押されました。")
                FormRevocateCert02.TextBoxAuthority.Text = FormRevocateCert01.ComboBoxAuthority.Text
                FormRevocateCert02.ListView1.Items.Clear()
                If FormRevocateCert01.ListView1.Items IsNot Nothing Then
                    RevoCount = 0
                    For i As Integer = 0 To FormRevocateCert01.ListView1.Items.Count - 1 Step 1
                        If FormRevocateCert01.ListView1.Items.Item(i).Checked Then
                            If FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(11).Text = "-" Then
                                Dim ItemTemp As ListViewItem = New ListViewItem(FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(0).Text)
                                For j As Integer = 1 To 11 Step 1
                                    ItemTemp.SubItems.Add(FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(j).Text)
                                Next
                                FormRevocateCert02.ListView1.Items.Add(ItemTemp)
                                RevoCount += 1
                            End If
                        End If
                    Next
                End If
                FormRevocateCert02.TextBoxRevocateDate.Text = DateTime.Parse(FormRevocateCert01.DateTimePickerRevocateDate.Value.ToString("yyyy/MM/dd 00:00:00"))
                FormRevocateCert02.TextBoxReasonCode.Text = FormRevocateCert01.ComboBoxReasonCode.Text
                FormRevocateCert02.Location = Me.Location          ' 入力確認画面を表示します
                FormRevocateCert02.ShowDialog()
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormRevocateCert02.CheckOk
        If FormRevocateCert02.CheckOk Then
            Debug.WriteLine("debug 入力確認画面で〔実行〕が押されました。")
            Dim FormRevocateCert03 As RevocateCert03 = New RevocateCert03 ' 実行します
            FormRevocateCert03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormRevocateCert03.K9piaExecName = BIdata.K9piaName
            FormRevocateCert03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormRevocateCert03.SerialNumber = New ArrayList
            If FormRevocateCert01.ListView1.Items IsNot Nothing Then
                For i As Integer = 0 To FormRevocateCert01.ListView1.Items.Count - 1 Step 1
                    If FormRevocateCert01.ListView1.Items.Item(i).Checked Then
                        If FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(11).Text = "-" Then
                            Dim ItemTemp As ListViewItem = New ListViewItem(FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(0).Text)
                            For j As Integer = 1 To 11 Step 1
                                ItemTemp.SubItems.Add(FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(j).Text)
                            Next
                            FormRevocateCert03.SerialNumber.Add(Long.Parse(FormRevocateCert01.ListView1.Items.Item(i).SubItems.Item(0).Text))
                        End If
                    End If
                Next
            End If
            FormRevocateCert03.RevocateDate = FormRevocateCert01.DateTimePickerRevocateDate.Value
            FormRevocateCert03.ReasonCode = FormRevocateCert01.ComboBoxReasonCode.SelectedIndex + 1
            FormRevocateCert03.RGdata = Me.RGdata
            FormRevocateCert03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
            FormRevocateCert03.ShowDialog()
            If FormRevocateCert03.CheckOk Then
                Debug.WriteLine("debug 実行画面が終了しました。")
                Dim FormRevocateCert04 As RevocateCert04 = New RevocateCert04
                FormRevocateCert04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormRevocateCert04.ShowDialog()

                BIdata.WriteFile()
                Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                '                                                        ツリーを表示します
                Me.TreeViewDisplay()
                Me.CertTableClear()
            Else
                Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
            End If
        End If
    End Sub

    ' ****** メニューから認証局業務→失効リストの作成を選択されたときの処理です ******
    Private Sub 失効リストの作成LToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 失効リストの作成LToolStripMenuItem.Click
        Dim FormCreateX509Crl01 As CreateX509crl01 = New CreateX509crl01
        FormCreateX509Crl01.RGdata = Me.RGdata
        FormCreateX509Crl01.BIdata = Me.BIdata
        Do
            FormCreateX509Crl01.Location = Me.Location                ' 入力画面を表示します
            FormCreateX509Crl01.ShowDialog()
            If FormCreateX509Crl01.CheckOk Then
                Debug.WriteLine("debug 入力画面で〔OK〕が押されました。")
            Else
                Debug.WriteLine("debug 入力画面で〔キャンセル〕が押されました。")
                Exit Do
            End If
        Loop Until FormCreateX509Crl01.CheckOk
        If FormCreateX509Crl01.CheckOk Then
            Debug.WriteLine("debug 入力画面で〔OK〕が押されました。")
            Dim FormCreateX509Crl03 As CreateX509crl03 = New CreateX509crl03 ' 実行します
            FormCreateX509Crl03.K9piaExecDirectory = BIdata.BaseDirectory & BIdata.K9piaDirectory
            FormCreateX509Crl03.K9piaExecName = BIdata.K9piaName
            FormCreateX509Crl03.K9piaCertDirectoryBase = BIdata.BaseDirectory & BIdata.CertDirectory
            FormCreateX509Crl03.Issuer = FormCreateX509Crl01.AuthList.SerialNumber(FormCreateX509Crl01.ComboBoxAuthority.SelectedIndex)
            Dim SNempty As Boolean
            For Retry As Integer = 0 To 10 Step 1
                Dim SNtemp As String = RGdata.GetString(BIdata.SerialNumberCrl, CommonDefines.RecordSirinumber)
                If String.IsNullOrEmpty(SNtemp) Then
                    SNempty = True
                    FormCreateX509Crl03.SerialNumber = BIdata.SerialNumberCrl
                    Exit For
                Else
                    SNempty = False
                    BIdata.NextSerialNumberCrl()
                End If
            Next
            If SNempty Then
                Dim TempUpdate As Date = FormCreateX509Crl01.DateTimePickerThisUpdate.Value
                If (TempUpdate.Year = DateTime.Today.Year) And (TempUpdate.Month = DateTime.Today.Month) And (TempUpdate.Day = DateTime.Today.Day) Then
                    FormCreateX509Crl03.ThisUpdate = DateTime.Now
                Else
                    FormCreateX509Crl03.ThisUpdate = New DateTime(TempUpdate.Year, TempUpdate.Month, TempUpdate.Day, 0, 0, 0)
                End If
                FormCreateX509Crl03.NextUpdate = Date.Parse(FormCreateX509Crl01.TextBoxNextUpdate.Text)
                FormCreateX509Crl03.RGdata = Me.RGdata
                FormCreateX509Crl03.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                FormCreateX509Crl03.ShowDialog()
                If FormCreateX509Crl03.CheckOk Then
                    Debug.WriteLine("debug 実行画面が終了しました。")
                    Dim FormCreateX509Crl04 As CreateX509crl04 = New CreateX509crl04
                    FormCreateX509Crl04.Issuer = FormCreateX509Crl01.AuthList.SerialNumber(FormCreateX509Crl01.ComboBoxAuthority.SelectedIndex)
                    FormCreateX509Crl04.SerialNumber = FormCreateX509Crl03.SerialNumber
                    FormCreateX509Crl04.ThisUpdate = FormCreateX509Crl03.ThisUpdate
                    FormCreateX509Crl04.K9piaCertDirectoryBase = FormCreateX509Crl03.K9piaCertDirectoryBase
                    FormCreateX509Crl04.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
                    FormCreateX509Crl04.ShowDialog()                      ' 証明書の取得先を表示します

                    BIdata.NextSerialNumberCrl()
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                    '                                                        ツリーを表示します
                    Me.TreeViewAddCrl(FormCreateX509Crl04.SerialNumber, FormCreateX509Crl04.Issuer)
                Else
                    Debug.WriteLine("debug 実行画面で〔キャンセル〕が押されました。")
                    BIdata.NextSerialNumberCrl()                       ' シリアル番号を欠番にする
                    BIdata.WriteFile()
                    Debug.WriteLine("debug 基本情報ファイルを更新しました。")
                End If
            Else
                Dim msg As String = "シリアル番号に空きが見つかりませんでした。"
                msg &= "処理を中止します。"
                MessageBox.Show(msg, "システムエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    ' ****** メニューからその他→ログ表示を選択されたときの処理です ******
    Private Sub ログ表示LToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ログ表示LToolStripMenuItem.Click
        Dim FormOther As DispLog = New DispLog
        FormOther.LogDirectory = Me.BIdata.BaseDirectory & Me.BIdata.LogDirectory
        FormOther.LogName = Me.BIdata.LogName
        FormOther.Location = Me.Location
        FormOther.ShowDialog()
    End Sub

    ' ****** メニューからその他→ドキュメントを選択されたときの処理です ******
    Private Sub ドキュメントDToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ドキュメントDToolStripMenuItem.Click
        Dim FormOther As DispIndex = New DispIndex
        FormOther.Location = Me.Location
        FormOther.ShowDialog()
    End Sub

    ' ****** メニューからその他→バージョン情報を選択されたときの処理です ******
    Private Sub バージョン情報AToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles バージョン情報AToolStripMenuItem.Click
        Dim FormOther As DispVersion = New DispVersion
        FormOther.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
        FormOther.ShowDialog()
    End Sub

    ' ****** メニューからその他→お問い合わせを選択されたときの処理です ******
    Private Sub お問い合わせCToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles お問い合わせCToolStripMenuItem.Click
        Dim FormOther As DispContact = New DispContact
        FormOther.Location = New Point((Me.Location.X + 200), (Me.Location.Y + 100))
        FormOther.ShowDialog()
    End Sub
End Class
